<?php
//----------------------------------------------------------------------------------
// CAPTION
//----------------------------------------------------------------------------------
$netblog_capts = array();

$netblog_captdft = array(
	'name' => '',
	'type' => '',
	'ref' => '',
	'title' => '',
	'format' => 'decimal',
	'display' => 'inline',
	'local' => 'false',
	'print' => '($number)'
);
$netblog_captCur = array();
$netblog_captNum = array();
$netblog_captPos = 0;

function netblog_caption( $atts, $content = null )
{
	global $netblog_capts, $netblog_captdft, $netblog_captCur, $netblog_captNum;
	global $isSavePost, $netblog_captPos;
	
	$a = shortcode_atts( $netblog_captdft, $atts );
	$a['type'] = strtolower($a['type']);
	extract($a);
	
	// FIRST CALL SAVES SESSION SETTINGS (for each type)
	if( strlen($type) > 0 ) {
		if( !isset($netblog_captCur[$type]) ) $netblog_captCur[$type] = $a;
		$local = $netblog_captCur[$type]['local'];
		$print = $netblog_captCur[$type]['print'];
		$format = $netblog_captCur[$type]['format'];
		$display = $netblog_captCur[$type]['display'];
	}

	// VERIFY FORMAT
	$mapFormat = array( '1'=>'decimal','a'=>'lower-alpha','A'=>'upper-alpha','I'=>'upper-roman','i'=>'lower-roman','alpha'=>'lower-greek');
	if( isset($mapFormat[$format]) ) $format = $mapFormat[$format];

	if( $name == '' && $ref == '' ) return;
	$name = netblog_caption_verifyName($name);
	
	if( $local == 'true' ) {
		if( $name != '' && !isset($netblog_capts[$type][$name]) ) {
			// INCREMENT NUMBERING
			if( !isset($netblog_captNum[$type]) ) $netblog_captNum[$type] = 1;
			else $netblog_captNum[$type]++;// = netblog_caption_increment( $netblog_captNum[$type] );
			
			// SAVE CAPTION
			$number = netblog_caption_increment($netblog_captNum[$type],$format,0);
			$netblog_capts[$type][$name] = $number;
			
			// PRINT
			$c = '<a name="nbcaption-'.$name.'" title="'.ucfirst($type).' '.$number.': '.ucfirst($name).'">'.eval("return \"$print\"; ").'</a>';
			if( $display == 'right' )
				$c = '<div style="float:right; padding-left: 10px">'.$c.'</div>';
			else if( $display == 'left' )
				$c = '<div style="float:left; padding-right: 10px">'.$c.'</div>';
			return $c;
			
		} else if( $ref != '' && isset($netblog_capts[$type][$name]) ) {
			$number = $netblog_capts[$type][$name];
			return '<a href="#nbcaption-'.$ref.'" style="text-decoration:none" title="'.ucfirst($type).' '.$number.': '.ucfirst($ref).'">'.eval("return \"$print\"; ").'</a>';
		} else if( $ref != '' ) {			
			// TRY TO RECOVER TYPE - only possible if name is unique
			$typeNew = '';
			foreach( $netblog_capts as $t=>$c )
				if( isset($c[$ref]) && strlen($typeNew) == 0 )
					$typeNew = $t;
				else if( isset($c[$ref]) ) {
					$typeNew = ''; break;
				}
			if( strlen($typeNew) > 0 ) {
				$number = $netblog_capts[$typeNew][$ref];
				$print = $netblog_captCur[$typeNew]['print'];
				if( $a['print'] != '' && $a['print'] != $netblog_captdft['print'] )
					$print = $a['print'];
				return '<a href="#nbcaption-'.$ref.'" style="text-decoration:none" title="'.ucfirst($typeNew).' '.$number.': '.ucfirst($ref).'">'.eval("return \"$print\"; ").'</a>';
			}				
		}
		return '<font style="color:red; font-style:italic">['.__('Invalid caption numbering','netblog').']</font>';
		
	} else {
		if( $isSavePost ) {
			if( $name != '' && !isset($netblog_capts[$type][$name]) ) {
				// INCREMENT NUMBERING
				if( !isset($netblog_captNum[$type]) ) $netblog_captNum[$type] = 1;
				else $netblog_captNum[$type]++;
				
				// SAVE CAPTION
				$number = netblog_caption_increment($netblog_captNum[$type],$format,0);
				$netblog_capts[$type][$name] = $number;					// required to distinguish between new and old captions	
				
				return netblog_caption_add( $name, $type, $_POST['post_ID'], $number, $netblog_captPos++, $title, $print, $format, $display );				
			}	
		} else {
			if( $name != '' ) {
				$capt = netblog_caption_get($name,$type);
				if( $capt != null ) {
					extract($capt);				
					$number = $capt['num'];
					if( strlen($title) == 0 ) $title = $name;
					if( strlen($print) == 0 ) $print = '($number)';
					
					$g = netblog_caption_global_get($type);
					if( $g['active'] ) {
						$display = $g['display'];
						$print = $g['print_format'];						
					}
							
					$c = '<a name="nbcaption-'.$name.'" title="'.ucfirst($type).' '.$number.': '.ucfirst($title).'">'.eval("return \"$print\"; ").'</a>';
					if( $display == 'right' )
						$c = '<div style="float:right; padding-left: 10px">'.$c.'</div>';
					else if( $display == 'left' )
						$c = '<div style="float:left; padding-right: 10px">'.$c.'</div>';
					return $c;
				}
			} else {
				$capt = netblog_caption_get($ref,$type);
				if( $capt != null ) {
					extract($capt);
					$number = $num;	
					if( strlen($title) == 0 ) $title = $name;	
					if( strlen($print) == 0 ) $print = '($number)';		

					$g = netblog_caption_global_get($type);
					if( $g['active'] ) {
						$display = $g['display'];
						$print = $g['print_format'];						
					}
					
					return '<a href="'.get_permalink($host).'#nbcaption-'.$ref.'" style="text-decoration:none" title="'.ucfirst($type)
							.' '.$number.': '.ucfirst($title).'">'.eval("return \"$print\"; ").'</a>';						
				}
			}
		}
		return '<font style="color:red; font-style:italic">['.__('Invalid caption numbering','netblog').']</font>';
	}
	
}



//---------------------------------------------------------------------------------------------------------------------
// HELPER METHODS
//---------------------------------------------------------------------------------------------------------------------
function netblog_caption_increment( $num, $type = 'decimal', $step = 1 )
{
	if( ($type == 'alpha' || $type == 'lower-alpha' || $type == 'upper-alpha') && is_numeric($num) ) {
		$num = netblog_dec2alpha($num);
		if( $type == 'upper-alpha' ) $num = strtoupper($num);		
	}
	
	if( $type == 'alpha' || $type == 'decimal' || $type == 'lower-alpha' || $type == 'upper-alpha' ) {
		$t = explode('.',$num);
		if( $step == 1 )
			$t[sizeof($t)-1]++;
		else if( $step == -1 )
			$t[sizeof($t)-1]--;
		return implode('.',$t);
	}
	if( $type == 'lower-greek' || $type == 'upper-greek' || $type == 'greek' ) {
		if( $step == 1 ) $num++;
		else if( $step == -1 ) $num--;
		
		if( !is_numeric($num) )		
			$alphaint = netblog_alpha2decimal($num);
		else $alphaint = array($num);
		
		$greek = '';
		$start = 944;		// &#955; := alpha
		if( $type == 'upper-greek' ) $start = 912;		
		foreach( $alphaint as $int )
			$greek .= '&#'.($start+$int).';';
		return $greek;
	}
	if( $type == 'lower-roman' || $type == 'upper-roman' || $type == 'roman' ) {
		if( !is_numeric($num) ) {
			$r = netblog_alpha2decimal($num);
			$num = 0;
			foreach( $r as $k )
				$num += $k;
		}
		if( $step == 1 ) $num++;
		if( $step == -1 ) $num--;
		$r = netblog_dec2roman( $num );
		if( $type == 'lower-roman' ) $r = strtolower($r);
		return $r;
	}	
}
function netblog_caption_verifyName( $name )
{
	return preg_replace("/[^a-zA-Z0-9]/", "", $name);
}
function netblog_alpha2decimal( $alpha )
{
	$t = array('a'=>1,'b'=>2,'c'=>3,'d'=>4,'e'=>5,'f'=>6,'g'=>7,'h'=>8,'i'=>9,'j'=>10,'k'=>11,'l'=>12,'m'=>13,'n'=>14,'o'=>15,
			'p'=>16,'q'=>17,'r'=>18,'s'=>19,'t'=>20,'u'=>21,'v'=>22,'w'=>23,'x'=>24,'y'=>25,'z'=>26);	
	if( strlen($alpha) == 1 ) {

		if( isset($t[$alpha])) return array($t[$alpha]);
		else return array(0);
	} else {
		$a = str_split($alpha);
		$v = array();
		foreach( $a as $char ) 
			if( isset($t[$char]) ) $v[] = $t[$char];
		
		return $v;
	}
}
function netblog_dec2alpha( $dec )
{
	$t = 'a';
	for( $i=1; $i<$dec; $i++ )
		$t++;
	return $t;
}

function netblog_dec2roman($num) 
{
    $n = intval($num);
    $res = '';
 
    /*** roman_numerals array  ***/
    $roman_numerals = array(
                'M'  => 1000,
                'CM' => 900,
                'D'  => 500,
                'CD' => 400,
                'C'  => 100,
                'XC' => 90,
                'L'  => 50,
                'XL' => 40,
                'X'  => 10,
                'IX' => 9,
                'V'  => 5,
                'IV' => 4,
                'I'  => 1);
 
    foreach ($roman_numerals as $roman => $number) 
    {
        /*** divide to get  matches ***/
        $matches = intval($n / $number);
 
        /*** assign the roman char * $matches ***/
        $res .= str_repeat($roman, $matches);
 
        /*** substract from the number ***/
        $n = $n % $number;
    } 
    return $res;
}


//---------------------------------------------------------------------------------------------------------------------
// REGISTER CAPTION - NBCAPTION
//---------------------------------------------------------------------------------------------------------------------
add_shortcode( constant('NETBLOG_CAPTION_TAG'), 'netblog_caption');


?>