<?php

//----------------------------------------------------------------------------------
// COMMON DB-QUERIES
//----------------------------------------------------------------------------------
function netblog_getURIDbyName( $uri )
{
	global $wpdb; 
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = addslashes($uri);
	$r = $wpdb->get_row("SELECT * FROM `$ext` WHERE uri = '$uri'",ARRAY_A);
	if( $wpdb->num_rows > 0 ) return $r['uri_id'];
	else return -1;
}
function netblog_isAdjacent( $nodeID, $childNode, $extern = false )
{
	global $wpdb; 
	if($extern) {
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		$childNode = addslashes($childNode);
		$query = "
			SELECT * FROM `$ext` e, `$rel` r
			WHERE r.uri_id = e.uri_id
			AND r.id = $nodeID
			AND e.uri = '$childNode'
		";
		return $wpdb->get_row($query) != null;
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		return $wpdb->get_row("SELECT * FROM `$net` WHERE id = $nodeID AND adj_id = $childNode") != null;
	}
}
function netblog_hasAdjacent( $nodeID, $extern = false )
{
	global $wpdb; 
	if($extern) {
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		return $wpdb->get_row("SELECT * FROM `$rel` WHERE id = $nodeID LIMIT 1") != null;
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		return $wpdb->get_row("SELECT * FROM `$net` WHERE id = $nodeID LIMIT 1") != null;
	}
}
function netblog_removeAdjacent( $nodeID, $childNode, $extern = false )
{
	global $wpdb; 
	if($extern){
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		
		//if( !netblog_hasAdjacent($nodeID,true) ) return false;
		
		$uriID = netblog_getURIDbyName($childNode);
		$res = $wpdb->query("DELETE FROM `$rel` WHERE id = $nodeID AND uri_id = $uriID");
		$wpdb->query("UPDATE `$ext` SET refs = refs-1 WHERE uri_id = $uriID");
		
		if( $wpdb->query("SELECT * FROM `$rel` WHERE uri_id = $uriID") == null )
			$wpdb->query("DELETE FROM `$ext` WHERE uri_id = $uriID");
		
		return !($res == false || $res <= 0);		
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		$res = $wpdb->query("DELETE FROM `$net` WHERE id = $nodeID AND adj_id = '$childNode'");
		return !($res == false || $res <= 0);
	} 	
}
function netblog_removeURI( $uri )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
	
	$id = netblog_getURIDbyName($uri);
	$wpdb->query("DELETE FROM `$rel` WHERE uri_id = $id");
	$res = $wpdb->query("DELETE FROM `$ext` WHERE uri_id = $id");
	return !($res == false || $res <= 0);	
}

function netblog_removeURIFromNode( $nodeID, $uri )
{
	return netblog_removeAdjacent($nodeID,$uri,true);
}
function netblog_removeNode( $nodeID )
{
	$adj = netblog_getAdjacents($nodeID, true, true );
	foreach( $adj as $e )
		if( !netblog_removeAdjacent($nodeID,$e['uri'],true) )
			return false;
	return true;
}
function netblog_addAdjacent( $nodeID, $childNode, $extern = false, $uriTitle = '' )
{
	global $wpdb;
	
	if( netblog_isAdjacent($nodeID,$childNode,$extern) )
		return false;
	
	if($extern){		
		$childNode = addslashes($childNode);
		$uriTitle = addslashes( strip_tags($uriTitle) );
		if( strlen($uriTitle) == 0 ) return false;		
		
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		
		$uri_id = netblog_addURI($childNode,$uriTitle);		
		$res = $wpdb->query("INSERT INTO `$rel` (id,uri_id) VALUES ('$nodeID','$uri_id')");
		
		return !($res == false || $res <= 0);
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
		$res = $wpdb->query("INSERT INTO `$net` (id,adj_id) VALUES ('$nodeID','$childNode')");
		return !($res == false || $res <= 0);
	} 
}
function netblog_getNodesByAdjacent( $childNode, $extern = false )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
			
	if($extern){
		$uri = addslashes($childNode);
		$query = "
			SELECT ext.uri, ext.uri_title, ext.uri_id, p.ID, p.post_title, p.post_date, p.post_status, p.post_type
			FROM `$ext` ext, `$rel` rel, $wpdb->posts p
			WHERE ext.uri = '$uri'
			AND ext.uri_id = rel.uri_id
			AND rel.id = p.id
			ORDER BY p.post_date;
		";
		return $wpdb->get_results($query,ARRAY_A);		
	} else {
		return array();
	}
}
function netblog_getNodesByAdjacentAsString( $childNode, $extern = false, $limit = -1 )
{
	$arr = netblog_getNodesByAdjacent($childNode,$extern);
	if($extern) {
		$num = 0;$out = Array();
		foreach( $arr as $row )
			if( $num++ < $limit || $limit == -1 )
				$out[] = $row['post_title'];
		return implode(', ', $out);
	} else {
		return '';
	}
}

function netblog_updateURI( $uri, $title ) 
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = addslashes($uri);
	$uriTitle = addslashes( strip_tags($uriTitle) );
	if( strlen($uriTitle) == 0 ) return false;	
	
	$res = $wpdb->query("UPDATE `$ext` SET uri_title = '$uriTitle' WHERE uri = '$uri'");
	return !($res == false || $res <= 0);
}
function netblog_updateURIbyID( $uri_id, $uri, $title, $flag = -1 ) 
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = trim(addslashes($uri));
	$flag = (int) $flag;
	$uriTitle = trim(addslashes( strip_tags($title) ));
	
	if( strlen($uriTitle) == 0 ) return false;	

	$res = array();
	if( $flag < 0 || !is_int($flag) )
		$res = $wpdb->query("UPDATE `$ext` SET uri_title = '$uriTitle', uri = '$uri' WHERE uri_id = $uri_id");
	else $res = $wpdb->query("UPDATE `$ext` SET uri_title = '$uriTitle', uri = '$uri', flag = '$flag' WHERE uri_id = $uri_id");
	return !($res == false || $res <= 0);
}


function netblog_addURI( $uri, $title )
{
	global $wpdb; 
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = trim(addslashes($uri));
	$uriTitle = trim(addslashes( strip_tags($title) ));
		
	$id = netblog_getURIDbyName($uri);	
	if( $id == -1 ) {
		$wpdb->query("INSERT INTO `$ext` (uri,uri_title) VALUES ('$uri','$title')");
		$id = $wpdb->insert_id;
	} else $wpdb->query("UPDATE `$ext` SET refs = refs+1 WHERE uri_id = $id");
	return $id;		
}
function netblog_getURI( $uri )
{
	global $wpdb; 
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$uri = addslashes($uri);
	return $wpdb->get_row("SELECT * FROM `$ext` WHERE uri = '$uri'", ARRAY_A);
}
function netblog_getAdjacents( $nodeID, $fetchInfos = false, $extern = false )
{
	global $wpdb; 
	
	if($extern){
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		$childNode = addslashes($childNode);
		$query = "
			SELECT * FROM `$ext` e, `$rel` r
			WHERE r.uri_id = e.uri_id
			AND r.id = $nodeID
			ORDER BY e.uri
		";
		return $wpdb->get_results($query, ARRAY_A);
	} else {
		$net = $wpdb->prefix . constant('NETBLOG_DB_NET');	
		if( !$fetchInfos )
			$query = "
			    SELECT *
			    FROM `$net`
			    WHERE id = $nodeID;
			";
		else 
			$query = "
			    SELECT p.ID, post_title, user_nicename, post_date, post_status, post_type, post_mime_type
			    FROM $wpdb->posts p, `$net` n, $wpdb->users u
		      	WHERE n.id = $nodeID
		      	AND n.adj_id = p.ID
		      	AND p.post_author = u.ID
			    AND (p.post_type = 'post' || p.post_type = 'page' || p.post_type = 'attachment' )
			    ORDER BY p.post_title;
			";																				//UPDT_1.2 - page
		return $wpdb->get_results($query, ARRAY_A);
	}	
}
function netblog_getInfos( $nodeID )
{
	global $wpdb;
	$query = "
	    SELECT p.ID, post_title, user_nicename, post_date, post_status, post_type, post_mime_type
	    FROM $wpdb->posts p, $wpdb->users u
      	WHERE p.id = $nodeID
      	AND p.post_author = u.ID
	    AND (p.post_type = 'post' || p.post_type = 'page' || p.post_type = 'attachment' )
	    ORDER BY p.post_date DESC;
	";																								//UPDT_1.2 - page
	$adjs = $wpdb->get_results($query, ARRAY_A);
	
	if( $adjs[0]['post_type'] == 'attachment' )
		$adjs[0]['post_type'] = $adjs[0]['post_mime_type'];
	unset($adjs[0]['post_mime_type']);
	
	if( $adjs[0]['post_status'] == 'inherit' )
		$adjs[0]['post_status'] = 'publish';
		
	return $adjs;	
}
function netblog_getPostType( $nodeID )
{
	$nd = netblog_getInfos($nodeID);
	return $nd[0]['post_type'];
}

function netblog_updt_post_parse( $k )
{
	return substr($k, strpos($k,'-')+1 );
}







/*
 * URI-DB OPS
 */
function netblog_get_uris( $orderBy, $limit = -1, $flag = NULL, $refs = 0 )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$desc = strtoupper($desc);
	
	// VERIFY
	$q = "SELECT * FROM `$ext`";
	$order = Array();
	$validTbl = array('uri_id'=>'uri_id','id'=>'uri_id','title'=>'uri_title','uri_title'=>'uri_title','refs'=>'refs','flag'=>'flag');
	foreach( $orderBy as $by ) {
		if( is_string($by) ) $by = explode(' ',$by);					
		if( !isset($by[0]) || !isset($validTbl[$by[0]]) || isset($order[$validTbl[$by[0]]]) ) continue;
		
		$t = $validTbl[$by[0]];
		if( isset($by[1]) && strtolower($by[1]) == 'desc' )
			$t .= ' DESC';
		$order[$validTbl[$by[0]]] = $t;
	}
	
	if( $flag != null ) {
		$flagMap = array('online'=>0, 'offline'=>1, 'trash'=>2, 'lock'=>99);
		if( isset($flagMap[$flag]) ) $flag = $flagMap[$flag];
		else $flag = null; 
	}
	
	// BUILD SQL-CMD
	if( $flag != null )
		$q .= " WHERE flag = $flag";
	if( sizeof($order) > 0 )
		$q .= " ORDER BY ".implode(', ',$order);
	if( is_numeric($limit) && $limit > 0 )
		$q .= " LIMIT $limit";
//var_dump($q);
	return $wpdb->get_results($q,ARRAY_A);
}


function netblog_get_uris_match( $match, $orderBy = array('uri_title'), $limit = -1, $flag = NULL )
{
	global $wpdb;
	$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$rel = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
	
	// VERIFY
	$match = addslashes($match);
	$q = "	SELECT e.uri_id, e.uri, e.uri_title, e.flag, e.refs, p.post_title
			FROM `$ext` e, $wpdb->posts p, `$rel` rel
			WHERE rel.uri_id = e.uri_id
			AND rel.id = p.ID
			AND (e.uri LIKE '%$match%' || e.uri_title LIKE '%$match%' || p.post_title LIKE '%$match%' )			
		";
	
	$order = Array();
	$validTbl = array('uri_id'=>'e.uri_id','id'=>'e.uri_id','title'=>'e.uri_title','uri_title'=>'e.uri_title'
			,'refs'=>'e.refs','flag'=>'e.flag','post_title'=>'p.post_title','post_id'=>'p.ID');
	foreach( $orderBy as $by ) {
		if( is_string($by) ) $by = explode('-',$by);					
		if( !isset($by[0]) || !isset($validTbl[$by[0]]) || isset($order[$validTbl[$by[0]]]) ) continue;
		
		$t = $validTbl[$by[0]];
		if( isset($by[1]) && strtolower($by[1]) == 'desc' )
			$t .= ' DESC';
		$order[$validTbl[$by[0]]] = $t;
	}
	
	if( $flag != null ) {
		$flagMap = array('online'=>0, 'offline'=>1, 'trash'=>2, 'lock'=>99);
		if( isset($flagMap[$flag]) ) $flag = $flagMap[$flag];
		else $flag = null; 
	}
	
	// BUILD SQL-CMD
	if( $flag != null )
		$q .= " AND flag = $flag";
		
	$q .= " GROUP BY e.uri_id";
	
	if( sizeof($order) > 0 )
		$q .= " ORDER BY ".implode(', ',$order);
	if( is_numeric($limit) && $limit > 0 )
		$q .= " LIMIT $limit";
//var_dump($q);			
	return $wpdb->get_results($q,ARRAY_A);
}



//---------------------------------------------------------------------------------------------------------------------
// CAPTION
//---------------------------------------------------------------------------------------------------------------------

function netblog_caption_add( $name, $type, $host, $figure, $position = '-1', $title, $printFormat, $numberFormat = 'decimal', $display = 'inline' )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
	
	if( !current_user_can( get_option('netblog_caption_gadd') ) ) return false;
	
	if( $type == '' ) $type = netblog_caption_recover_type($name);	
	
	// APPLY GLOBAL STYLE
	$optG = netblog_caption_global_get($type);
	if( $optG != null && $optG['active'] ) {
		$printFormat = $optG['print_format'];
		$numberFormat = $optG['number_format'];		
	}
	
	// CONVERT DECIMAL FIGURE TO NUMBER FORMAT
	$figure = netblog_caption_increment($figure,$numberFormat,0);
	
	// AUTOMATICALLY ADD NEW TYPE STYLES
	if( $optG == null ) {
		netblog_caption_global_set($type, $numberFormat, $printFormat, $display );
	}
	
	if( netblog_caption_exists($name,$type) ) {
		netblog_caption_update($name,$type, $host, $figure,$title,$printFormat);
		return netblog_caption_reorder($name,$type,$host, $position);
	}
	
	$name = addslashes($name);
	$type = addslashes($type);
	$figure = addslashes($figure);
	$title = addslashes($title);
	$printFormat = addslashes($printFormat);
	
	// NEW CAPTION
	$count = netblog_caption_countH($host);
	if( $position < 0 )
		$position = $count;
	else if( $position >= $count ) $position = $count;
	else $wpdb->query("UPDATE `$capt` SET local_order = local_order+1 WHERE host = $host AND type = '$type' AND local_order >= $position");
	
	// HOST ORDER - INSERT AT BOTTOM
	$host_order = netblog_caption_get_hostOrder($host);
	if( $host_order == -1 )
		$host_order = netblog_caption_get_maxHostOrder() + 1;
	
	$figure = $host_order . '.' . $figure;
		
	$wpdb->query("INSERT INTO `$capt` (name,type,num,host,local_order,title,print,host_order) VALUES ('$name','$type','$figure','$host','$position','$title','$printFormat','$host_order')");
	if( $wpdb->num_rows == 0 ) return false;
	
	// NEW HOST - maybe
	//netblog_host_add($host);
	 
	return true;
}
function netblog_caption_remove( $name, $type )
{
	if( !netblog_caption_exists($name,$type) ) return false;
	
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');

	extract( netblog_caption_get($name,$type) );
	$wpdb->query("UPDATE `$capt` SET local_order = local_order-1 WHERE host = $host AND type = '$type' AND local_order > $local_order");
	$d = $wpdb->query("DELETE FROM `$capt` WHERE id = $id");
	if( netblog_caption_countH($host) == 0 )
		$wpdb->query("UPDATE `$capt` SET host_order = host_order-1 WHERE host_order > $host_order");
		
	return $d > 0;
}
function netblog_caption_rmByHost( $host ) 
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	$h = $wpdb->get_row("SELECT * FROM `$capt` WHERE host = $host LIMIT 1", ARRAY_A);
	if( $h == null ) return false;
	extract($h);
	
	$d = $wpdb->query("DELETE FROM `$capt` WHERE host = $host");
	$wpdb->query("UPDATE `$capt` SET host_order = host_order-1 WHERE host_order > $host_order");
	return $d>0;
}
function netblog_caption_update( $name, $type, $host, $numbering, $title, $printFormat )
{
	$c = netblog_caption_get($name,$type);
	if( $c == null ) return false;
	$id = $c['id'];
	
	$name = addslashes($name);
	$type = addslashes($type);
	$numbering = addslashes($numbering);
	$title = addslashes($title);
	$printFormat = addslashes($printFormat);

	$host_order = netblog_caption_get_hostOrder($host);
	$numbering = $host_order . '.' . $numbering;
	
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');	
	$wpdb->query("UPDATE `$capt` SET num = '$numbering', title = '$title', print = '$printFormat' WHERE id = $id");	
	return true;	
}
function netblog_caption_rebuild()
{
	$all = netblog_caption_getall();
	$hostsDone = array();
	
	foreach( $all as $capt ) {		
		$host = $capt['host'];
		if( isset($hostsDone[$host])) continue;
		
		$page = get_page($host, ARRAY_A);
		$_POST['post_content'] = $page['post_content'];
		$_POST['post_ID'] = $host;
		netblog_save_postdata($host);
	}
	return true;
}

function netblog_caption_countH( $host )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	$wpdb->query("SELECT id FROM `$capt` WHERE host = $host");
	return $wpdb->num_rows;
}
function netblog_caption_get_maxHostOrder()
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	$r = $wpdb->get_row("SELECT host_order FROM `$capt` ORDER BY host_order DESC LIMIT 1", ARRAY_A);
	if( $wpdb->num_rows > 0 )
		return $r['host_order'];
	else return 0;
}
function netblog_caption_get_hostOrder( $host )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	$r = $wpdb->get_row("SELECT host_order FROM `$capt` WHERE host = '$host' LIMIT 1", ARRAY_A);	
	if( $wpdb->num_rows > 0 )
		return $r['host_order'];
	else return -1;	
}

function netblog_caption_exists( $name, $type )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');

	return $wpdb->get_row("SELECT * FROM `$capt` WHERE name = '$name' AND type = '$type'") != null;
}
function netblog_caption_existinHost( $name, $type, $host, $position = '-1' )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	
	if( $position < 0 )
		return $wpdb->get_row("SELECT * FROM `$capt` WHERE name = '$name' AND host = $host AND type = '$type'") != null;
	else  return $wpdb->get_row("SELECT * FROM `$capt` WHERE name = '$name' AND host = $host AND type = '$type' AND local_order = $position") != null;
}
function netblog_caption_recover_type( $name )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');

	$c = $wpdb->get_results("SELECT * FROM `$capt` WHERE name = '$name' LIMIT 2", ARRAY_A);
	if( $wpdb->num_rows == 1 ) return $c[0]['type'];
	else return '';
}

function netblog_caption_hasOrder( $name, $type, $position )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');	
	return $wpdb->get_row("SELECT * FROM `$capt` WHERE name = '$name' AND type = '$type' AND local_order = $position") != null;
}
function netblog_caption_reorder( $name, $type, $host, $position )
{
	if( !netblog_caption_existinHost($name,$type,$host) ) return false;
	if( netblog_caption_existinHost($name,$type,$host,$position) ) return false;
	
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	
	$count = netblog_caption_countH($host);
	if( $position < 0 )
		$position = $count-1;
	else if( $position >= $count ) $position = $count-1;
	
	$caption = netblog_caption_get($name,$type);
	$posOld = $caption['local_order'];
	$captionID = $caption['id'];
	
	$wpdb->query("UPDATE `$capt` SET local_order = local_order-1 WHERE host = $host AND type = '$type' AND local_order > $posOld");	
	$wpdb->query("UPDATE `$capt` SET local_order = local_order+1 WHERE host = $host AND type = '$type' AND local_order >= $position");
	$wpdb->query("UPDATE `$capt` SET local_order = $position WHERE id = $captionID");	
	return true;
}
function netblog_caption_getorder( $name, $type )
{
	$r = netblog_caption_get($name,$type);
	if( isset($r['local_order']) )
		return $r['local_order'];
	else return -1;
}
function netblog_caption_get( $name, $type )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	
	$c = $wpdb->get_row("SELECT * FROM `$capt` WHERE name = '$name' AND type = '$type'", ARRAY_A);
	if( $c == null ) {
		$typeRec = netblog_caption_recover_type($name);
		if( $typeRec != $type )
			return $wpdb->get_row("SELECT * FROM `$capt` WHERE name = '$name' AND type = '$typeRec'", ARRAY_A);
	} else return $c;
}
function netblog_caption_by_host( $host )
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	return $wpdb->get_results("SELECT * FROM `$capt` WHERE host = $host", ARRAY_A );	
}
function netblog_caption_getall()
{
	global $wpdb;
	$capt = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	return $wpdb->get_results("SELECT * FROM `$capt` ORDER BY name, id", ARRAY_A );
}


function netblog_caption_global_set( $type, $numberFormat = 'decimal', $printFormat = '($number)', $display = 'inline', $active = true )
{
	$mapNumF = array('decimal'=>1,'lower-alpha'=>2,'upper-alpha'=>3,'lower-roman'=>4,'upper-roman'=>5,'lower-greek'=>6);
	$mapDsp = array('inline'=>1,'left'=>2,'right'=>3);
	$mapAct = array(true=>1,false=>2);
	
	// VERIFY
	if( !isset($mapNumF[$numberFormat]) ) $numberFormat = 'decimal';
	if( !isset($mapDsp[$display]) ) $display = 'inline';
	if( !is_bool($active) ) $active = true;
	//if( $active )
	$type = strtolower($type);
	
	$code = $mapAct[$active] . $mapDsp[$display] . $mapNumF[$numberFormat] . '|' . $printFormat;
	$opt = 'nbcaption-type-'.$type;

	if( !get_option($opt) )
		add_option($opt,$code);
	else update_option($opt,$code);	
}
function netblog_caption_global_rm( $type )
{
	$type = strtolower($type);
	$opt = 'nbcaption-type-'.$type;
	if( get_option($opt) )
		return delete_option($opt);
	return false;	
}
function netblog_caption_global_get( $type )
{		
	$type = strtolower($type);
	$opt = get_option('nbcaption-type-'.$type);
	if( !$opt ) return null;
	return netblog_caption_global_parse($opt);
}
function netblog_caption_global_types( $fetch_infos = false )
{
	global $wpdb;
	$res = $wpdb->get_results("SELECT * FROM $wpdb->options WHERE option_name LIKE 'nbcaption-type-%'", ARRAY_A);
	$types = array();
	foreach( $res as $r ) {
		$type = substr( $r['option_name'], strlen('nbcaption-type-') );
		$types[$type] = $type;
		if( $fetch_infos ) {
			$types[$type] = netblog_caption_global_parse($r['option_value']);			
		}		
	}
	return $types;
}
function netblog_caption_global_parse( $option_string )
{
	$mapNumF = array('decimal'=>1,'lower-alpha'=>2,'upper-alpha'=>3,'lower-roman'=>4,'upper-roman'=>5,'lower-greek'=>6);
	$mapDsp = array('inline'=>1,'left'=>2,'right'=>3);
	$mapAct = array(true=>1,false=>2);
		
	$out = array();	
	$t = explode('|',$option_string,2);
	$code = str_split($t[0]);
	$out['active'] = (bool) array_search( (int)($code[0]), $mapAct );
	$out['display'] = array_search( (int)$code[1], $mapDsp );
	$out['number_format'] = array_search( (int)($code[2]), $mapNumF );
	$out['print_format'] = $t[1];
	return $out;	
}


//---------------------------------------------------------------------------------------------------------------------
// HOST
//---------------------------------------------------------------------------------------------------------------------
function netblog_host_exists( $host )
{
	global $wpdb;
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
	return $wpdb->get_row("SELECT * FROM `$hostdb` WHERE host = $host") != null;
}
function netblog_host_add( $host )
{
	if( netblog_host_exists($host) ) return false;

	global $wpdb;
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
	
	$last = netblog_host_last();
	if( $wpdb->num_rows == 0 )
		$last = array( 'parent'=>'0','host_order'=>-1 );
	$wpdb->query("INSERT INTO `$hostdb` (host,parent,host_order) VALUES ('$host','".$last['parent']."','".($last['host_order']+1)."')");
	return $wpdb->num_rows == 1;	
}
function netblog_host_get( $host )
{
	global $wpdb;
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
	return $wpdb->get_row("SELECT * FROM `$hostdb` WHERE host = $host", ARRAY_A);	
}
function netblog_host_maxorder()
{
	$r = netblog_host_last();
	if( isset($r['host_order']) ) return $r['host_order'];
	else return -1;
}
function netblog_host_last()
{
	global $wpdb;
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
	return $wpdb->get_row("SELECT * FROM `$hostdb` ORDER BY host_order DESC LIMIT 1", ARRAY_A);	
}
function netblog_host_reorder( $host, $step )
{
	if( $step == 0 ) return false;
	if( !netblog_host_exists($host) ) return false;
	
	global $wpdb;
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');

	extract( netblog_host_get($host) );
	$orderMax = netblog_host_maxorder();
	$orderGoal = $host_order+$step;
	
	if( $host_order+$step > $orderMax ) $step = $orderMax-$host_order;
	else if( $host_order+$step < 0 ) $step = -$host_order;
	
	$dir = $step > 0 ? 1 : -1;
	
	if( $step < 0 ) {
		$wpdb->query("UPDATE `$hostdb` SET host_order = host_order+1 WHERE host_order >= $orderGoal AND host_order < $host_order ");
	} else
		$wpdb->query("UPDATE `$hostdb` SET host_order = host_order-1 WHERE host_order <= $orderGoal AND host_order > $host_order ");
		
	// UPDATE PARENT AND LEVEL ENTRIES OF MOVED HOST
	$parent = $wpdb->query("SELECT * FROM `$hostdb` WHERE host_order < $orderGoal AND level < $level ORDER BY host_order DESC, level DESC LIMIT 1");
	if( $parent == null )
		$parent = array( 'host'=>0, 'level'=>-1);
	$levelNew = $parent['level'] + 1; $par = $parent['host'];
	$wpdb->query("UPDATE `$hostdb` SET level = $levelNew, parent = $par WHERE host = $host");
	
	return true;	
}
function netblog_host_indent( $host, $levelDir = 1 )
{
	if( $levelDir == 0 ) return false;
	if( !netblog_host_exists($host) ) return false;
	
	global $wpdb;
	$hostdb = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
	
	extract( netblog_host_get($host) );
	if( $host_order == 0 ) return false;
	
	$levelNew = $level + $levelDir;
	if( $levelNew < 0 ) $levelNew = 0;
	
	$par = $wpdb->query("SELECT * FROM `$hostdb` WHERE host_order < $host_order AND level < $levelNew ORDER BY host_order DESC, level DESC LIMIT 1");
	if( $par == null )
		$par = array( 'host'=>0, 'level'=>-1);
	$levelNew = $par['level'] + 1; $parent = $par['host'];
	$wpdb->query("UPDATE `$hostdb` SET level = $levelNew, parent = $parent WHERE host = $host");			

	return true;
}












?>