<?php
//----------------------------------------------------------------------------------
// INSTALL, ACTIVATION, DEACTIVATION
//----------------------------------------------------------------------------------
function netblog_install()
{
	global $wpdb;
   
	netblog_register_constants( array('NETBLOG_VERSION','NETBLOG_AUTOCOMPLETE_MINLEN','NETBLOG_BLOGSEARCH_URI','NETBLOG_BLOGSEARCH_MAX',
				'NETBLOG_BLOGSEARCH_PROVIDER_NAME','NETBLOG_BLOGSEARCH_PROVIDER_URI','NETBLOG_WEBSEARCH_URI','NETBLOG_WEBSEARCH_MAX',
				'NETBLOG_WEBSEARCH_PROVIDER_NAME','NETBLOG_WEBSEARCH_PROVIDER_URI','NETBLOG_WEBSEARCH_KEYWORDS' ));
	
	if( !get_option('netblog_caption_gadd') ) add_option('netblog_caption_gadd','delete_pages');
	if( !get_option('netblog_cite_style') ) add_option('netblog_cite_style','apa');
	if( !get_option('netblog_cite_style_override') ) add_option('netblog_cite_style_override','false');
	if( !get_option('netblog_note_format') ) add_option('netblog_note_format','decimal');
	if( !get_option('netblog_mel_read') ) add_option('netblog_mel_read','edit_posts');
	if( !get_option('netblog_mel_edit') ) add_option('netblog_mel_edit','delete_pages');
		else update_option('netblog_mel_edit','delete_pages');
	if( !get_option('netblog_mel_start_tpl') ) add_option('netblog_mel_start_tpl','new');
	if( !get_option('netblog_mel_tpl') ) add_option('netblog_mel_tpl','true');
	if( !get_option('netblog_mel') ) add_option('netblog_mel','true');	
	if( get_option('netblog_websearch_keywords') ) delete_option('netblog_websearch_keywords');
	if( !get_option('netblog_mel_save') ) add_option('netblog_mel_save','20');
	if( !get_option('netblog-export-build') ) add_option('netblog-export-build','save_post');
	if( !get_option('netblog-footprints') ) add_option('netblog-footprints','false');
	
	
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

	// TABLES CAPTION
	$tbl = $wpdb->prefix . constant('NETBLOG_DB_CAPTION');
	if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
		$sql = "CREATE TABLE " . $tbl . " (
			  id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
			  name VARCHAR(125) NOT NULL,
			  type VARCHAR(32) NOT NULL,
			  num VARCHAR(32) NOT NULL,
			  host BIGINT(20) NOT NULL,
			  host_order INT NOT NULL,
			  title VARCHAR(255),			  
			  local_order INT NOT NULL,
			  print VARCHAR(64) NOT NULL,
			  PRIMARY KEY  (id)
			);";      
		dbDelta($sql);
		add_option("netblog_db_caption_ver", constant('NETBLOG_DB_CAPTION_VER') );
	}
	
	// FOOTPRINTS
	$tbl = $wpdb->prefix . constant('NETBLOG_DB_FOOTPRINT');
	if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
		$sql = "CREATE TABLE " . $tbl . " (
			  id BIGINT(20) UNSIGNED NOT NULL,
			  footprint VARCHAR(45) NOT NULL
			);";      
		dbDelta($sql);
		add_option("netblog_db_footprint_ver", constant('NETBLOG_DB_FOOTPRINT_VER') );
	}
	nbdb::footprt_createAll();
		
//	$tbl = $wpdb->prefix . constant('NETBLOG_DB_HOST_TREE');
//	if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
//		$sql = "CREATE TABLE " . $tbl . " (
//			  host BIGINT(20) UNSIGNED NOT NULL,
//			  parent BIGINT(20) UNSIGNED NOT NULL,
//			  host_order BIGINT(20) UNSIGNED NOT NULL,
//			  level INT NOT NULL DEFAULT 0,
//			  UNIQUE KEY host_parent  (host,parent)
//			);";      
//		dbDelta($sql);
//		add_option("netblog_db_host_tree_ver", constant('NETBLOG_DB_HOST_TREE_VER') );
//	}
	
	
	if( get_option("netblog_db_ext_ver") == '1.0' )
		return netblog_upgd_db10();
	
	$tbl = $wpdb->prefix . constant('NETBLOG_DB_NET');
	if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
		$sql = "CREATE TABLE " . $tbl . " (
			  id BIGINT(20) UNSIGNED NOT NULL,
			  adj_id BIGINT(20) UNSIGNED NOT NULL,
			  UNIQUE KEY netblogAdj  (id,adj_id)
			);";      
		dbDelta($sql);
		add_option("netblog_db_net_ver", constant('NETBLOG_DB_NET_VER') );
	}
 
	// MAX MEDIUMINT: 16777215 (unsigned)
 	$tbl = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	//if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
		$sql = "CREATE TABLE " . $tbl . " (
			  uri_id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
			  uri VARCHAR(512) NOT NULL,
			  uri_title VARCHAR(127) NOT NULL,
			  flag INT(10),
			  refs MEDIUMINT NOT NULL DEFAULT 1,
			  footprint VARCHAR(45),
			  PRIMARY KEY  (uri_id)
			);";      
   		dbDelta($sql);
		update_option("netblog_db_ext_ver", constant('NETBLOG_DB_EXT_VER') );
	//}
	
 	$tbl = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
	if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
		$sql = "CREATE TABLE " . $tbl . " (
			  id BIGINT(20) UNSIGNED NOT NULL,
			  uri_id BIGINT(20) UNSIGNED NOT NULL,
			  UNIQUE INDEX `netblog_rel_extnode`  (id,uri_id)
			);";      
   		dbDelta($sql);
		add_option("netblog_db_rel_extnode_ver", constant('NETBLOG_DB_REL_EXTNODE_VER') );
	}
		
}

// FIRST VERSION - NOTHING TO UPGRADE
function netblog_upgrade()
{
	$ver = get_option("netblog_db_ext_ver");
	
	if( $ver == false ) return netblog_install();
	
	if( !get_option( "netblog_version" ) )
		add_option('netblog_version', constant('NETBLOG_VERSION') );
	update_option('netblog_version', constant('NETBLOG_VERSION') );
		
	if( $ver == '1.0')
		return netblog_upgd_db10();
		
	return false;
}

function netblog_upgd_db10()
{
	global $wpdb;
	
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	
	// CREATE TABLE REL EXT
	if( !get_option('netblog_db_rel_extnode_ver') || get_option('netblog_db_rel_extnode_ver') !=  constant('NETBLOG_DB_REL_EXTNODE_VER')) {
	 	$tbl = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
		if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
			$sql = "CREATE TABLE " . $tbl . " (
				  id BIGINT(20) UNSIGNED NOT NULL,
				  uri_id BIGINT(20) UNSIGNED NOT NULL,
				  UNIQUE INDEX `netblog_rel_extnode`  (id,uri_id)
				);";   
			//$wpdb->query($sql);   
	   		dbDelta($sql);
	   		
	   		if( !get_option('netblog_db_rel_extnode_ver') )
				add_option("netblog_db_rel_extnode_ver", constant('NETBLOG_DB_REL_EXTNODE_VER') );
			else update_option("netblog_db_rel_extnode_ver", constant('NETBLOG_DB_REL_EXTNODE_VER') );
		}
	}
	
	if( !get_option('netblog_db_ext_ver') ) {
	 	$tbl = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		if($wpdb->get_var("SHOW TABLES LIKE '$tbl'") != $tbl) {      
			$sql = "CREATE TABLE " . $tbl . " (
				  uri_id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
				  uri VARCHAR(512) NOT NULL,
				  uri_title VARCHAR(127) NOT NULL,
				  flag INT(10),
			  	  refs MEDIUMINT NOT NULL DEFAULT 1,
			  	  footprint VARCHAR(45),
				  PRIMARY KEY  (uri_id)
				);";      
	   		dbDelta($sql);
			add_option("netblog_db_ext_ver", constant('NETBLOG_DB_EXT_VER') );
		}
		return true;		
	}
	
	// UPDATE TABLE EXT
	if( get_option('netblog_db_ext_ver') <= '1.0' ) {
		$ext = $wpdb->prefix . constant('NETBLOG_DB_EXT');
		$sql = "SELECT * FROM `$ext`";
		$res = $wpdb->get_results($sql, ARRAY_A);
		
			$wpdb->query("DROP TABLE `$ext`");
			     
			$sql = "CREATE TABLE `$ext` (
				  uri_id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
				  uri VARCHAR(512) NOT NULL,
				  uri_title VARCHAR(127) NOT NULL,
				  flag INT(10),
			 	  refs MEDIUMINT NOT NULL DEFAULT 1,
			 	  footprint VARCHAR(45),
				  PRIMARY KEY  (uri_id)
				);";
			//$wpdb->query($sql);
	   		dbDelta($sql);
			update_option("netblog_db_ext_ver", constant('NETBLOG_DB_EXT_VER') );
		
		foreach( $res as $row ) {
			netblog_addAdjacent( $row['id'], $row['uri'], true, $row['uri_title'] );
		}
	}	
	return true;
}

function netblog_deactivate()
{
	remove_action('admin_menu', 'netblog_plugin_menu');
}

function netblog_uninstall()
{
	global $wpdb;
	
	// REMOVE DATABASE TABLES
	$dbtbl = array();
	$dbtbl[] = $wpdb->prefix . constant('NETBLOG_DB_NET');
	$dbtbl[] = $wpdb->prefix . constant('NETBLOG_DB_EXT');
	$dbtbl[] = $wpdb->prefix . constant('NETBLOG_DB_REL_EXTNODE');
	
	foreach( $dbtbl as $tbl ) {
		if( $wpdb->get_var("SHOW TABLES LIKE '$tbl'") == $tbl )
			$wpdb->query("DROP TABLE `$tbl`");
	}
	
	// REMOVE OPTIONS
	delete_option("netblog_version" );
	delete_option("netblog_db_net_ver" );
	delete_option("netblog_db_ext_ver" );
	delete_option("netblog_db_rel_extnode_ver" );
}

function netblog_register_constants( $array )
{
	foreach( $array as $nm ) {
		if( !defined($nm) ) continue;
		$nmL = strtolower($nm);
		if( !get_option($nmL) )
			add_option($nmL, constant($nm) );
		else update_option($nmL, constant($nm) );			 
	}
}

?>