<?php
//----------------------------------------------------------------------------------
// METABOX FURTHER READING FOR POST/PAGE
//----------------------------------------------------------------------------------
add_action('admin_init', 'netblog_post_add_metabox');

function netblog_post_add_metabox()
{
	if( function_exists('add_meta_box') ) {
		add_meta_box('netblog_post_interface', 'Further Reading', 'netblog_post_interface', 'post', 'advanced','high');
		add_meta_box('netblog_post_interface', 'Further Reading', 'netblog_post_interface', 'page', 'advanced','high');
	} else {
		//add_action('dbx_post_advanced', 'myplugin_old_custom_box' ); 
	}
	netblog_plugin_styles();		
}

function netblog_post_interface()
{
	global $post;
	$nodeID = $post->ID;
	
	// VERIFY
	echo '<input type="hidden" name="netblog_noncename" id="netblog_noncename" value="' . 
	wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
	
	// METABOX CONTENT
	?>
	<div class="netblog-container" id="nb-popup" style="display:none"></div>
	
	<div class="netblog-post-container" style="width:100%;">
		
		<div>
            <div class="input-autocomplete" style="width:100%;">      
                <div class="input-autocomplete-txt" id="input-autocomplete-txt1">
	                <input type="text" name="text-input" id="input-autocomplete1" value="" class="text-input" autocomplete="off" /></div>                     
                <div class="input-autocomplete-wnd" id="input-autocomplete-wnd1"></div>
               
                <div class="helpS"><?php _e('Type a name to search for posts, pages and other resources in the internet.','netblog');
                	echo ' <a href="netblog.benjaminsommer.com/resources">'.__('Learn more about resources.','netblog').'</a>'; ?></div>    
            </div>
            <div class="input-autocomplete-btn" >
	            <!-- <input type="button" value="Add Link" onclick="addAdjNode(box.getCurRowID(),box.getCurRowValue())"  
	            	id="input-autocomplete-submit1" class="button"/> -->
            </div> 
            <div style="float:none; clear:both"></div>
        </div> 
        <div class="hr"></div>
        <div class="lister" id="netblog-post-container-lister"></div>
        
        <script language="javascript">
     
        /* AUTOCOMPLETE BOX */
        	if( typeof(netblog_autocomplete) == 'function' ) {
				var box = new netblog_autocomplete();
				box.setInputDefaultValue('<?php _e('Search for resources','netblog') ?>' );
				box.setMinInputLength(<?php echo constant('NETBLOG_AUTOCOMPLETE_MINLEN'); ?>);
				box.setFooter(' <?php echo '<a href="'.constant('NETBLOG_WEBSEARCH_PROVIDER_URI').'">'.constant('NETBLOG_WEBSEARCH_PROVIDER_NAME').'</a>' ?> ');
				box.createGroup( 'intern', '<?php _e('Your Wordpress site','netblog') ?>' );
				box.createGroup( 'extern', '<?php _e('World Wide Web','netblog') ?>' );
				box.init( 'input-autocomplete-txt', 'input-autocomplete1', 'input-autocomplete-wnd1', 'box', box );	
				
				var iconUri = {'pdf':'<?php echo WP_PLUGIN_URL . '/netblog/images/external-link-ltr-icon.png' ?>'};			
				
				function boxFormatPrint( row )
				{
					var match = box.getInputStr();
					var title = row[0];
					var out;					
					
					// EXTERN - WWW
					if( row[5] == 'extern' ) {
						var uriF = row[6];
						var uriParse = parseUri( row[6] );
						var titleF = row[0];
						
						// REMOVE CHAR / FROM END OF URI - nicer
						if( uriF.substring( uriF.length - 1 ) == '/' || uriF.substring( uriF.length - 1 ) == '\\' )
							uriF = uriF.substring(0, uriF.length - 1 );
									
						// FORMAT TLD
						if( uriParse.tld != 'undefined' )
							uriF = uriF.replace( uriParse.tld, '<font class="tld">' + uriParse.tld + '</font>' );
						
						
						// FORMAT PROTOCOL
						var protos = ['http://www.','http://','ftp://','https://'];
						protos: for( i=0; i<protos.length; i++ ) {
							var t = uriF.match( new RegExp( protos[i], "i") );
							if( t  != null )
							for( s=0; s<t.length; s++ ) {
								uriF = uriF.replace( t[s], '<small>' + t[s] + '</small>' );
								break protos;
							}
						}
						

						// FORMAT MATCHES
						var t = box.getInputStr();
						var matches = t.split(' ');
						for( i=0; i<matches.length; i++ ) {								
							var m = matches[i];
							
							if( m == 'www' || m == 'http://' ) continue; 
							
							//uriF = uriF.replace( m, '<b>'+m+'</b>' );
							// URI
							var t = uriF.match( new RegExp( m, "gi" ) );														
							if( t != null )
							for( s=0; s<t.length; s++ )								
								uriF = uriF.replace( t[s], '<b>'+t[s]+'</b>' );
															
							// TITLE
							var t = titleF.match( new RegExp( m, "gi" ) );														
							if( t != null )
							for( s=0; s<t.length; s++ )								
								titleF = titleF.replace( t[s], '<b>'+t[s]+'</b>' );
						}
						out = uriF + '&nbsp;&nbsp;<small class="title">' + titleF + '</small>';
						
					// INTERN - LOCAL
					} else {
						t = title.match( new RegExp( match, "gi" ) );
						if( t != null )
						for( s=0; s<t.length; s++ )
							title = title.replace( t[s], '<b>'+t[s]+'</b>' );	
							
						// ICON
						var iconClass = '';
						switch( row[5] ) { // type
						case 'post': case 'page': iconClass = row[5]; break;
						case 'application/pdf': case 'pdf': iconClass = 'pdf'; break;
						}		
						var out = '<div class="iconS '+ iconClass +'"></div>' + title + ' <small class="title">&nbsp;&nbsp;&mdash; '+row[5]+'&nbsp;&nbsp;Author:'+row[2]+'&nbsp;&nbsp;<?php _e('Published','netblog') ?>:'+row[3]+'</small>';
//						if( row[1].length > 5 )
//							out += '<br /><dfn>'+row[1]+'</dfn>';
					}
					return out;
				}
				function boxFormatInput( row )
				{
					if( row[6] != '' )
						return row[6]; 
					return row[0]; 
				}
					
				box.RegisterCBFormater( this, boxFormatPrint, '' );
				box.RegisterCBFormaterInput( this, boxFormatInput, '' );
				
			} else document.getElementById('netblog-post-container-lister').innerHTML += '<?php _e('Unable to load autocomplete box Handler!','netblog') ?><br />';
			
		/* LISTER */
			if( typeof(netblog_lister) == 'function' ) { 
				var list = new netblog_lister();
				
				list.init('netblog-post-container-lister','list');
				list.setSortImmediate(false);
				list.setAppendMode(2);
				list.setSubmenuMode(2);
				list.setFormatMode(3);
				list.setOnRemoveWaitFeedback(true);
				
				/* CUSTOM ROW FORMATER */
				function formater( id, array, remove )
				{
					if( array[5] == 'extern' ) {
						var uriF = array[6];
					
						// REMOVE CHAR / FROM END OF URI - nicer
						if( uriF.substring( uriF.length - 1 ) == '/' || uriF.substring( uriF.length - 1 ) == '\\' )
							uriF = uriF.substring(0, uriF.length - 1 );
												
						// NICE APPEARANCE FOR PROTOCOL										
						var protos = ['http://www.','http://','ftp://','https://'];
						var i;
						protos: for( i=0; i<protos.length; i++ ) {
							var t = uriF.match( new RegExp( protos[i], "i") );
							if( t  != null )
							for( s=0; s<t.length; s++ ) {
								uriF = uriF.replace( t[s], '<em>' + t[s] + '</em>' );
								uriF = uriF.replace( '</em>', '</em><b>' );
								uriF += '</b>';
								break protos;
							}
						}	
											
						return '<a onclick="nbpopup_load(\''+array[0]+'\',\''+array[6]+'\')" class="right" ><?php echo _x('visit','url','netblog') ?></a>'+uriF+'&nbsp;&nbsp;<em class="title">'+array[0]+'</em>';
					} else {
						// ICON
							var iconClass = '';
							switch( array[5] ) { // type
							case 'post': case 'page': iconClass = array[5]; break;
							case 'application/pdf': case 'pdf': iconClass = 'pdf'; break;
							}
							
						var uriF = array[0];
										
						// PRINT						
						return '<a onclick="nbpopup_load(\''+array[0]+'\',\''+array[6]+'\')" class="right" ><?php echo _x('read','post','netblog') ?></a><a href="'+array[7]+'" class="right" ><?php echo _x('edit', 'post','netblog') ?></a>'+
							'<div class="iconS '+ iconClass +'"></div><strong>'+uriF+'</strong>&nbsp;&nbsp;<em>&mdash; <?php _e('Author','netblog') ?>:'+array[2]+'</em><br/>'+
							'<dfn> <?php _e('Published on','netblog') ?> '+array[3]+' <?php _e('as','netblog') ?> '+array[5]+'</dfn>';
					}
				}	
				list.registerCBFormatElem( this, formater, '','','' );
					
			} else 	document.getElementById('netblog-post-container-lister').innerHTML += '<?php _e('Unable to load List Handler!','netblog') ?>';
		
		/* AJAX HANDLER */
			var delim_main = '<?php echo constant('NETBLOG_AJAX_DELIM_KEYMAIN'); ?>';
			var delim_sub = '<?php echo constant('NETBLOG_AJAX_DELIM_KEYSUB'); ?>';
			var nodeID = <?php echo $nodeID ?>;	
			
			function getChildNodes() {
				jQuery(document).ready(function($) {
					var data = {
						action: 'send_childNodes',
						nodeID: nodeID
					};
					jQuery.post(ajaxurl, data, function(response) {
						var ar = interpretStr( response, delim_main, delim_sub );
						var i;
						for( i=0; i<ar.length; i++ )
							if( ar[i].length > 1 ) {
								var id = ar[i][0];
								var title = ar[i][1];
								var auth = ar[i][2];
								var date = ar[i][3];
								var status = ar[i][4];
								var type = ar[i][5];
								var permalink = ar[i][6];
								var editlink = ar[i][7];
								list.add(id, [title,'',auth,date,status,type,permalink,editlink]);
							}		
					});
				});			
			}

			function send( inputStr ) {
//				if( group == 'extern' )
//					inputStr = 'www ' + inputStr;
					
				jQuery(document).ready(function($) {
					var data = {
						action: 'send_autocompleteGroups',
						query: ''+inputStr,
						nodeID: nodeID
					};
					// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
					jQuery.post(ajaxurl, data, function(response) {
						var ar = interpretStr( response, delim_main, delim_sub );					
						box.clear();
						var hasExtern = false;
						for( i=0; i<ar.length; i++ )
							if( ar[i].length > 1 ) {																							
								var type = ar[i][0];								
								if( type == 'extern' ) {									
									var title = ar[i][1];
									var uri = ar[i][2];
									box.appendG( hex_md5(uri), [title, '', '', '', '', 'extern', uri], 'extern' );
									hasExtern = true;
								} else {
									var title = ar[i][1];
									var id = ar[i][2];
									var desc = ar[i][3];
									var auth = ar[i][4];
									var date = ar[i][5];
									var status = ar[i][6];
									var uri = ar[i][7];
									box.appendG( id, [title,desc,auth,date,status,type,uri], 'intern' );
									
								}
							}
						if( ar.length == 0 )
							box.hide(0);
						else box.show(0);
						if( hasExtern )
							box.printFooter();			
					});
				});
			}
			
			function addAdjNode( adjID, e )
			{
				if( e[5] == 'extern' ) {
					jQuery(document).ready(function($) {
						var data = {
							action: 'send_newAdjNodeExtern',
							nodeID: nodeID,
							uri: e[6],
							uri_title: e[0]
						};
						jQuery.post(ajaxurl, data, function(response) {
							if(stringCompare( response, 'true' ) == 0) {
								list.addBottom( hex_md5(e[6]), [e[0],'','','','','extern',e[6],''] );
								box.setInput('');
								return true
							} else 
								alert('<?php _e('Cannot add link','netblog') ?>');
							return false;					
						});
					});
				} else {				
					jQuery(document).ready(function($) {
						var data = {
							action: 'send_newAdjNode',
							nodeID: nodeID,
							adjNodeID: adjID
						};
						jQuery.post(ajaxurl, data, function(response) {
							var ar = interpretStr( response, delim_main, delim_sub );
							for( i=0; i<ar.length; i++ )
								if( ar[i].length > 1 ) {
									var id = ar[i][0];
									var title = ar[i][1];
									var auth = ar[i][2];
									var date = ar[i][3];
									var status = ar[i][4];
									var type = ar[i][5];
									var permalink = ar[i][6];
									var editlink = ar[i][7];
									list.addTop(id, [title,'',auth,date,status,type,permalink,editlink]);
									box.setInput('');
								}
							box.setInput('');					
						});
					});
				}
				
			}
			
			function removeAdjNode( adjID, e )
			{
				var childNode = adjID;
				if( e[5] == 'extern' )
					childNode = e[6];

				jQuery(document).ready(function($) {
					var data = {
						action: 'send_rmAdjNode',
						nodeID: nodeID,
						adjNodeID: childNode
					};
					jQuery.post(ajaxurl, data, function(response) {								
						if( stringCompare(response,'true') == 0 ) {
							list.removeOK(true);
							return true;							
						} else if( list.findRowID(adjID) != '' ) {
							alert('<?php _e('Error: cannot remove node','netblog') ?>');
							list.removeOK(false);
							return false;
						}
					});
				});						
			}
			function stringCompare( str1, str2 )
			{
				if( str1 < str2 ) return -1;
				if( str1 > str2 ) return 1;
				return 0;
			}
			
		/* RETRIEVE NEAR-MATCHED BASED ON [STR] -> AUTOCOMPLETE_BOX */
			box.RegisterCBAppend( this, send, '' );
			
		/* SEND AUTOCOMPLETE_BOX -> NEW NODE HANDLER -> SERVER | LISTER */
			box.RegisterCBChosen( this, addAdjNode, '', '' );
			
		/* SEND LISTER-REMOVED -> SERVER */
			list.registerCBOnRemoveElem( this, removeAdjNode, '', '' );
				
			getChildNodes();	
			
		/* POPUP INIT */
			nbpopup_issave(true);
			nbpopup_init('nb-popup');	

					
		</script>	

	</div>
	
	<?php
}
?>