<?php
//----------------------------------------------------------------------------------
// METABOX - REFERENCE MAKER
//----------------------------------------------------------------------------------
function netblog_mtbox_refmaker()
{
	if( function_exists('add_meta_box') ) {
		add_meta_box('netblog_refmaker', __('Reference Maker','netblog'), 'netblog_refmaker', 'post', 'side','');
		add_meta_box('netblog_refmaker', __('Reference Maker','netblog'), 'netblog_refmaker', 'page', 'side','');
	} else {
		//add_action('dbx_post_advanced', 'myplugin_old_custom_box' ); 
	}
	netblog_plugin_styles();		
}
add_action('admin_init', 'netblog_mtbox_refmaker');

function netblog_refmaker()
{
	?>
	<p>
	<!-- 
	<select onchange="mksubslct('nb-menu-main','menubody')" onkeyup="mksubslct('nb-menu-main','menubody')" id="nb-menu-main"><option >Create</option><option value="mk">Make</option><option value="ref">Reference</option></select>
	<span id="menubody" style="display: inline"></span><br /> -->
	<?php _e('Wizard','netblog') ?>: <select onchange="mkbodyS(this)" onkeyup="mkbodyS(this)" id="nb-menu">
		<optgroup label="<?php _e('Create','netblog') ?>">
			<option value="mk-note"><?php _e('Footnote','netblog') ?></option>
			<option value="mk-cite"><?php _e('Citation','netblog') ?></option>
			<option value="mk-caption"><?php _e('Caption','netblog') ?></option>
		</optgroup>
		<optgroup label="<?php _e('Cross-reference','netblog') ?>">
			<option value="ref-caption"><?php _e('Caption','netblog') ?></option>
		</optgroup>
		<optgroup label="<?php _e('Tables','netblog') ?>">
			<option value="lst-note"><?php _e('Footnotes','netblog') ?></option>
			<option value="mk-biblio"><?php _e('Bibliography','netblog') ?></option>
		</optgroup>
	</select>	
	</p>
	<hr style="border: 1px solid #DDD" />
	<div id="nb-mk-note" style="display:none">
		<p>
		<input type="checkbox" name="print" value="true" onclick="note_toogle('nb-mk-note-content','nb-mk-note-content-input')" id="nb-mk-note-print" /> 
			<label for="nb-mk-note-print"><?php _e('Print Footnotes','netblog') ?></label>
		</p>	
		<p id="nb-mk-note-content">
		<label for="nb-mk-note-content-input"><b><?php _e('Your Footnote','netblog') ?></b></label>
		<textarea rows="3" style="width:100%" name="content" id="nb-mk-note-content-input"></textarea>
		</p>	
		<p>
		<label for="nb-mk-note-go"><b><?php _e('Copy &amp; Paste','netblog') ?></b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-note',this)" name="nbnote" id="nb-mk-note-go"></textarea>
		</p>		
	</div>
	
	<?php
	$formats = array( 'decimal'=>1, 
					  'lower-alpha' => 'a', 'lower-greek'=>'a', 'lower-roman'=>1,
					  'upper-alpha'=> 'A', 'upper-roman' =>1 );
	foreach( $formats as $k=>$v ) {
		$t = array();
		$i = 1;
		$t[0] = nbcpt::increment($i,$k,0);
		$t[1] = nbcpt::increment($i++,$k);
		$t[2] = nbcpt::increment($i++,$k);
		$t[3] = nbcpt::increment($i++,$k);
		$formats[$k] = implode(', ',$t) . ', ...';
	}	
	
	?>
	<div id="nb-mk-caption" style="display:none">
		<p>
		<label for="nb-mk-caption-type"><b><?php _e('Type','netblog') ?></b> <small>(<?php _e('required','netblog') ?>) 
				<a href="netblog.benjaminsommer.com/captions"><?php _e('Learn more about captions.','netblog') ?></a></small></label><br />
		<input type="text" name="type" style="width:100%" onblur="clean(this);str2alphanum(this);input_strip(this,32);" id="nb-mk-caption-type" />
		</p>
		<p>
		<label for="nb-mk-caption-name"><b><?php _e('Name','netblog') ?></b> <small>(<?php _e('must be unique for this site','netblog') ?>; <?php _e('required','netblog') ?>)</small></label><br />
		<input type="text" name="name" style="width:100%" onblur="clean(this);str2alphanum(this);input_strip(this,125);" id="nb-mk-caption-name" />
		</p>
		<p>
		<label for="nb-mk-caption-title"><?php _e('Title','netblog') ?> <small>(<?php _e('optional','netblog') ?>)</small></label><br />
		<input type="text" name="title" style="width:100%" onblur="clean(this);str2alphanum(this);input_strip(this,125);" id="nb-mk-caption-title" />
		</p>		
		<p>
		<label for="nb-mk-caption-format"><?php _e('Format','netblog') ?> <small>(<?php _e('optional','netblog') ?>)</small></label><br /><select name="format" id="nb-mk-caption-format" style="width:100%">
		<?php foreach( $formats as $k=>$v) echo '<option value="'.$k.'">'.$v.'</option>';  ?>
		</select>
		</p>
		<p>
		<label><?php _e('Display','netblog') ?> <small>(
			<?php /* translators: display mode of captions (left, right, inline, default). for each post and each caption type (if not global), this variable acts like a constant when first defined by the user  */ 
				_e('the first of each type per post counts','netblog') ?>)</small></label><br />
		<select style="width:100%" name="display">
			<option value=""><?php _e('Default','netblog') ?></option>
			<option value="inline"><?php _e('Inline','netblog') ?></option>
			<option value="right"><?php _e('Right','netblog') ?></option>
			<option value="left"><?php _e('Left','netblog') ?></option></select>
		</p>
		<p>
		<label for="nb-mk-caption-print"><?php _e('Print','netblog') ?> <small>(<?php printf(__('optional; e.g. %s or %s','netblog'),'($number)','[$number]') ?>)</small></label><br />
		<input type="text" name="print" style="width:100%" value="" onblur="clean(this)" id="nb-mk-caption-print" />
		</p>		
		<p>
		<label for="nb-mk-caption-go"><b><?php _e('Copy &amp; Paste','netblog') ?></b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-caption',this)" name="nbcaption" id="nb-mk-caption-go"></textarea>
		</p>		
	</div>	
	
	<?php
	// CITATION
	
	$cstyles = nbcstyle::getStyles();
	$cstylesPrint = $cstyles;
	if( $cstylesPrint == '' ) $cstylesPrint = __('none','netblog');
	
	// MK SELECT FILTER TYPE
	$selectFilterType = '';
	$t = nbcstyle::getDftTypes();
	foreach($t as $k=>$v)
		$selectFilterType .= "<option value=\"$k\">$v</option>";
		

	// MK SELECT CUSTOM STYLE
	$optioncStyle = '';
	$t = explode(', ',$cstyles);
	foreach( $t as $v )
		$optioncStyle .= "<option value=\"$v\">$v</option>";
	
	// MK SELECT DEFAULT STYLES
	$optionDftStyle = '';
	$t = nbcstyle::getDftStyles();
	foreach( $t as $k=>$v )
		$optionDftStyle .= "<option value=\"$k\">$v</option>";
	
	?>
	
	<div id="nb-mk-biblio" style="display:none" >
		<p>
		<label><b><?php _e('Print Style','netblog') ?></b></label><br />
		<select style="width:100%" id="nb-mk-biblio-print" name="print"><optgroup label="Built-in Styles">
			<option value="default"><?php _e('Default','netblog') ?></option><?php echo $optionDftStyle ?></optgroup>
				<optgroup label="<?php _e('Custom Styles','netblog') ?>"><?php echo $optioncStyle ?></optgroup></select>
		</p>
		<p>
		<label for="nb-mk-biblio-headline"><?php _e('Headline','netblog') ?> <small>(<?php _e('default: References','netblog') ?>)</small></label><br />
		<input type="text" name="print_headline" style="width:100%" onblur="clean(this)" id="nb-mk-biblio-headline" />
		</p>		
		
		<p>
		<label for="nb-mk-biblio-go"><b><?php _e('Copy &amp; Paste','netblog') ?></b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-biblio',this)" name="nbcite" id="nb-mk-biblio-go"></textarea>
		</p>		
	</div>	
	<div id="nb-lst-note" style="display:none" >
		<p>
		<label for="nb-lst-note-go"><b><?php _e('Copy &amp; Paste','netblog') ?></b></label>
		<textarea rows="3" style="width:100%" id="nb-lst-note-go">[nbnote print="true"]</textarea>
		</p>	
	</div>
	
		
	<?php
	
	

	// MK SELECT CUSTOM STYLE
	$cstyles = nbcstyle::getStyles(ARRAY_N);
	$optioncStyle = '';
	foreach( $cstyles as $v )
		if( strlen($v) > 0 )
		$optioncStyle .= "<option value=\"$v\">$v</option>";
	
	// MK SELECT DEFAULT STYLES
	$optionDftStyle = '';
	$t = nbcstyle::getDftStyles();
	foreach( $t as $v )
		$optionDftStyle .= "<option value=\"$v\">$v</option>";
		
//	// GET VALID ATTRIBUTES
//	$atts = nbcstyle::getDftAtts();
//	$attsNamed = nbcstyle::getDftAttsNamed();	
//	$attsBasics = ''; $attsAdv = ''; $attsBasicsNum = 10; $i = 0;
//	foreach( $atts as $type=>$dft ) {
//		if( substr($type,0,5) == 'print' || $type == 'type' ) continue;
//		if( $i==$attsBasicsNum ) { $attsBasics = $attsAdv; $attsAdv = ''; }
//		$attsAdv .= '<p><label for="nb-mk-cite-'.$type.'">'.ucfirst($attsNamed[$type]).'</label><br />
//			<input type="text" name="'.$type.'" value="'.$dft.'" style="width:100%" onblur="clean(this)" id="nb-mk-cite-'.$type.'" />
//			</p>';
//		$i++;
//	}
	
	?>
	<div id="nb-mk-cite" style="display:none">
		<p> <label><b><?php _e('Citation Style','netblog') ?></b>
				<small><a href="http://netblog.benjaminsommer.com/citation"><?php _e('Learn more','netblog') ?></a></small></label><br />
			<select onchange="getResourceTypes(this.value)" id="mtbrm_rscstyles">
				<optgroup label="<?php _e('Built-in Styles','netblog'); ?>"><?php echo $optionDftStyle ?></optgroup>
				<optgroup label="<?php _e('Custom Styles','netblog'); ?>"><?php echo $optioncStyle ?></optgroup></select>
		</p>
	
		<p id="mtbrm_rowtypes">
		<label><b><?php _e('Resource Type','netblog') ?></b> </label><br />
		<div id="mtbrm_rsctypes"></div><br />
		
		</p>
		
		<div id="mtbrm_rowatts">
			<div id="nb-mk-cite-attsdft"></div>
			<div id="nb-mk-cite-attsadv" style="display:none"></div>
			<div style="background:#EEE; padding: 5px; text-align: center; cursor:pointer" onclick="nb_cite_reveal('nb-mk-cite-attsadv',this)">
				<?php _e('Optional Fields','netblog') ?></div>
			
			 
			<p>
			<label for="nb-mk-cite-go"><b><?php _e('Copy &amp; Paste','netblog') ?></b></label>
			<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-cite',this)" name="nbcite" id="nb-mk-cite-go"></textarea>
			</p>
		</div>		
	</div>	

	
	<?php
	// GET ALL CAPTIONS IN DATABASE
	$captions = nbdb::cpt_getAll();
	$captionsGroupedF = array();
	foreach( $captions as $r )
		$captionsGroupedF[ $r['type'] ] .= '<option value="'.$r['type'].'-------'.$r['name'].'">'.$r['name'].' - '.$r['num'].'</option>';
	?>
	<div id="nb-ref-caption" style="display:none" >
		<?php 
		if( sizeof($captions) == 0 ) 
			echo __('No global captions found.','netblog');
		else {
		?>
		<p>
		<label><b>Global Captions</b></label><br />
		<select onchange="mkrefcaption( this.value, '-------','nb-ref-caption-type','nb-ref-caption-ref')" id="nb-ref-caption-select">
			<?php
			foreach( $captionsGroupedF as $type=>$ct ) {
				echo '<optgroup label="'.ucfirst($type).'">'.$ct.'</optgroup>';
			}
			?>
		</select>
		</p>
		
		<input type="hidden" name="type" value="" id="nb-ref-caption-type" />
		<input type="hidden" name="ref" value="" id="nb-ref-caption-ref" />
		
		<p>
		<label for="nb-ref-caption-go"><b><?php _e('Copy &amp; Paste','netblog') ?></b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-ref-caption',this)" name="nbcaption" id="nb-ref-caption-go"></textarea>
		</p>	
		<?php } ?>		
	</div>
	
	
	<div class="netblog-clear"></div>

	
	<script type="text/javascript">
	<!--
	
	/* AJAX HANDLER */
		var delim_main = '<?php echo constant('NETBLOG_AJAX_DELIM_KEYMAIN'); ?>';
		var delim_sub = '<?php echo constant('NETBLOG_AJAX_DELIM_KEYSUB'); ?>';
		var onload_opacity = 50;
	/*
	*	SELECT MENU CHOOSER - 2 LEVELS
	*/
	var main = [ {'val':'mk', 'print':'Make'}, {'val':'ref', 'print':'Reference'} ];
	var sub = [ {'val':'note', 'print':'Footnotes', 'parval':'mk'}, {'val':'cite', 'print':'Citation', 'parval':'mk'}, {'val':'caption', 'print':'Caption', 'parval':'mk'},
		{'val':'biblio', 'print':'Bibliography', 'parval':'mk'}, {'val':'caption', 'print':'Caption', 'parval':'ref'} ];

	function mksubslct( idmain, idsub )
	{
		var mainobj = document.getElementById(idmain);
		var subobj = document.getElementById(idsub);

		
		var i; var s = ' > <select onchange="mkbody(\'nb-menu-main\',\'nb-menu-sub2\')" onkeyup="mkbody(\'nb-menu-main\',\'nb-menu-sub2\')" id="nb-menu-sub2"><optgroup label="Type">';
		var count = 0;
		for( i=0; i<sub.length; i++ ) {
			if( sub[i].parval == mainobj.value ) {
				s += '<option value="'+ sub[i].val +'">'+ sub[i].print +'</option>';
				count++;
			}
		}
		s += '</optgroup></select>';
		if( count > 0 ) {
			subobj.innerHTML = s;
			mkbody('nb-menu-main','nb-menu-sub2');
		}
	}
	
	var bodyLast = null;
	function mkbody( idmain, idsub )
	{
		var mainobj = document.getElementById(idmain);
		var subobj = document.getElementById(idsub);
		var idbody = 'nb-' + mainobj.value + '-' + subobj.value;
		var body = document.getElementById(idbody);
		
		if( body != null ) {
			if( bodyLast != null ) bodyLast.style.display = 'none';
			body.style.display = 'block';
			bodyLast = body;
		}				
	}
	function mkbodyS( menuobj )
	{
		var body = document.getElementById( 'nb-' + menuobj.value );
		if( body == null ) return;
		
		if( bodyLast != null ) bodyLast.style.display = 'none';
		body.style.display = 'block';
		bodyLast = body;
	}


	function mktagByid( parseid, print2id ) {
		mktag( parseid, document.getElementById(print2id) );
	}
	function mktag( parseid, print2obj ) {
		var obj = document.getElementById(parseid);
		print2obj.innerHTML = '';
		var tagname = print2obj.name;		
		var tag = '[' + tagname;
		var content = '';
		
		var i;
		var input;
		input = obj.getElementsByTagName('input');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				content = input.item(i).value;
			else if( input.item(i).type == 'checkbox' && !input.item(i).checked )
				continue;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				tag += ' ' + input.item(i).name + '="' + input.item(i).value + '"';
		}
		input = obj.getElementsByTagName('select');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				content = input.item(i).value;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				tag += ' ' + input.item(i).name + '="' + input.item(i).value + '"';
		}
		input = obj.getElementsByTagName('textarea');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				content = input.item(i).value;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				tag += ' ' + input.item(i).name + '="' + input.item(i).value + '"';
		}			
		
		tag += ' ]';
		if( content.length > 0 )
			tag += content + '[/' + tagname + ']';
		
		print2obj.innerHTML = tag;
		print2obj.select();
	}
	
	
	function note_toogle( boxid, inputid )
	{
		var box = document.getElementById(boxid);
		if( box.style.display == 'block' || box.style.display == '' ) {
			box.style.display = 'none';
			document.getElementById(inputid).value = '';
		} else box.style.display = 'block';
		
	}
	function mkrefcaption( val, sep, typeid, refid )
	{
		var t = val.split(sep);
		document.getElementById(typeid).value = t[0];
		document.getElementById(refid).value = t[1];		
	}
	
	function clean(obj)
	{
		if( obj.value != 'undefined' && obj.value.length > 0 )
		{
			obj.value = obj.value.replace("\"", '' );
			obj.value = obj.value.trim();
		}
	}

	
	function nb_cite_reveal( id, fromobj )
	{
		var obj = document.getElementById(id);
		if( obj == null ) return;
		
		var d = obj.style.display;
		if( d == 'none' || d == '' ) {			
			showPlus(id,0,1000,true,true);
			fromobj.innerHTML = 'Less';
		} else {
			hidePlus(id,0,500,true,false);
			fromobj.innerHTML = 'More';
		}
	}
	

	function getResourceTypes( name_citationstyle ) {
		var slct = document.getElementById('mtbrm_rsctypes');
		var fields_default = document.getElementById('nb-mk-cite-attsdft');
		var fields_optional = document.getElementById('nb-mk-cite-attsadv');
		
		if( onload_opacity < 100 && onload_opacity > 0 ) {
			setOpacity('mtbrm_rowtypes', onload_opacity);
			setOpacity('mtbrm_rowatts', onload_opacity);
		}
		
		
		fields_default.innerHTML = '';
		fields_optional.innerHTML = '';
		slct.innerHTML = '';
		
		jQuery(document).ready(function($) {
			var data = {
				action: 'get_citation_rsctypes',
				citationstyle: name_citationstyle
			};
			jQuery.post(ajaxurl, data, function(response) {
				var ar = interpretStr( response, delim_main, delim_sub );				
				var fldReq = ' ', fldOpt = ' ';

				var i;
				for( i=0; i<ar.length; i++ )
					if( ar[i].length > 1 ) {
						var name = ar[i][0];
						var nicename = ar[i][1];
						var required = ar[i][2];
						if( required == '1' ) 
							fldReq += '<option value="'+name+'">'+nicename+'</option>';
						else fldOpt += '<option value="'+name+'">'+nicename+'</option>';
					}
				var t = '<optgroup label="<?php echo __('Available Resource Types','netblog') ?>">'+fldReq
								+'</optgroup><optgroup label="<?php echo __('Optional Resource Types','netblog') ?>">'+fldOpt+'</optgroup>';
				t = '<select style="width:100%" name="type" ' +
			 		'onchange="getCitStyleAtts(document.getElementById(\'mtbrm_rscstyles\').value, this.value)" >'+t+'</select>';
				slct.innerHTML = t;
						
				if( onload_opacity < 100 )
					setOpacity('mtbrm_rowtypes', 100);
					
				getCitStyleAtts(document.getElementById('mtbrm_rscstyles').value, document.getElementById('mtbrm_rsctypes').value);			
			});
		});			
	}
	
	
	
	function getCitStyleAtts( name_style, name_type ) {
		var fields_default = document.getElementById('nb-mk-cite-attsdft');
		var fields_optional = document.getElementById('nb-mk-cite-attsadv');
		
		if( onload_opacity < 100 && onload_opacity > 0 )
			setOpacity('mtbrm_rowatts', onload_opacity);
		
		save_fields('nb-mk-cite');
		
		//fields_default.innerHTML = '';
		//fields_optional.innerHTML = '';
		
		jQuery(document).ready(function($) {
			var data = {
				action: 'get_citation_fields',
				citationstyle: name_style,
				citationtype: name_type
			};
			jQuery.post(ajaxurl, data, function(response) {
				var ar = interpretStr( response, delim_main, delim_sub );
				var fldReq = '', fldOpt = '';
				var i;
				for( i=0; i<ar.length; i++ )
					if( ar[i].length > 1 ) {
						var name = ar[i][0];
						var nicename = ar[i][1];
						var info = ar[i][2];
						var required = ar[i][3];
				
						if( name.length == 0 ) continue;
				
						if( info.length > 0 ) info = ' <small>(' + info + ')</small>';
						if( required == '1' ) nicename = '<b>' + nicename + '</b>';
						
						var f = '<p><label for="nb-mk-cite-'+name+'">' + nicename + info + '</label><br />' +
								'<input type="text" name="'+name+'" value="" style="width:100%" onblur="clean(this)" ' +
								'id="nb-mk-cite-'+name+'" /></p>';
							
						if( required == '1' ) 
							fldReq += f;
						else fldOpt += f;
					}
					
				fields_default.innerHTML = fldReq;
				fields_optional.innerHTML = fldOpt;	
				load_fields('nb-mk-cite');
				
				if( onload_opacity < 100 )
					setOpacity('mtbrm_rowatts', 100);
			});
		});			
	}
	
	var fields_saved = [];	
	function save_fields( parseid )
	{
		var obj = document.getElementById(parseid);
		//fields_saved = [];
		
		var i;
		var input;
		input = obj.getElementsByTagName('input');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				continue;
			else if( input.item(i).type == 'checkbox' && !input.item(i).checked )
				continue;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				fields_saved.push( {'name':input.item(i).name, 'value':input.item(i).value} );
		}
	}
	
	function load_fields( parseid )
	{
		var obj = document.getElementById(parseid);
		
		var i;
		var input;
		input = obj.getElementsByTagName('input');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				continue;
			else if( input.item(i).type == 'checkbox' && !input.item(i).checked )
				continue;
			else if( input.item(i).name.length > 0 ) {
				var ii;
				for( ii=0; ii<fields_saved.length; ii++ ) {
					if( fields_saved[ii].name == input.item(i).name ) {
						input.item(i).value = fields_saved[ii].value; 
						break;
					}
				}		
			}			
		}
	}
	
	getResourceTypes(document.getElementById('mtbrm_rscstyles').value);		
			
	if( document.getElementById('nb-ref-caption-select') != null )
	mkrefcaption( document.getElementById('nb-ref-caption-select').value, '-------','nb-ref-caption-type','nb-ref-caption-ref');
	
	if( document.getElementById('nb-menu') != null )
		mkbodyS( document.getElementById('nb-menu') );
	
	//-->
	</script>
	
	
	<?php
}

?>