<?php

//----------------------------------------------------------------------------------
// SETTINGS PAGE
//----------------------------------------------------------------------------------
function netblog_settings()
{
	echo '<div class="wrap">
	<div id="icon-options-general" class="icon32"><br /></div>
	<h2>Netblog '.__( 'Settings', 'netblog').'</h2>';
	
	ob_start();
	netblog_settings_update( $_GET['sub'] );
	$o = ob_get_contents();
	ob_end_clean();
	if( strlen($o) > 2 )	
		echo '<div id="message" class="updated below-h2"><p>'.$o.'</p></div>';
	
	?>
	<br />
	<div class="netblog-main">
	<form action="<?php echo netblog_mkurl(); ?>" method="post">
		<div class="netblog-menu">
			<div class="right">
				<input type="checkbox" id="nb-help-enabled" name="nb-help-enabled" value="true" <?php echo isset($_POST['nb-help-enabled']) ? 'checked="checked"' : '' ?>> 
					<label for="nb-help-enabled"><?php _e('Enable Help','netblog') ?></label>
				<input type="submit" name="save" value="<?php _e('Save','netblog') ?>" style="font-weight:bold" />
			</div>		
			<a class="<?php echo netblog_settings_mkmenuclass('general'); ?>" href="<?php echo netblog_mkurl('sub=general') ?>"><?php _e('General','netblog') ?></a>
			<div class="sep"></div>
			<a class="<?php echo netblog_settings_mkmenuclass('note'); ?>" href="<?php echo netblog_mkurl('sub=note') ?>"><?php _e('Footnotes','netblog') ?></a>
			<a class="<?php echo netblog_settings_mkmenuclass('cite'); ?>" href="<?php echo netblog_mkurl('sub=cite') ?>"><?php _e('Citation','netblog') ?></a>
			<a class="<?php echo netblog_settings_mkmenuclass('fig'); ?>" href="<?php echo netblog_mkurl('sub=fig') ?>"><?php _e('Caption','netblog') ?></a>
			<!-- <div class="sep"></div>
			<a class="<?php echo netblog_settings_mkmenuclass('adv'); ?>" href="<?php echo netblog_mkurl('sub=adv') ?>"><?php _e('Under the Hood','netblog') ?></a> -->
			<div class="netblog-clear"></div>		
		</div>
		<div class="body">			
			<?php			
			$sub = '';
			if( isset($_GET['sub']) ) $sub = $_GET['sub'];
			switch($sub) {
				case 'note': echo netblog_setting_note(); break;
				case 'cite': echo netblog_setting_cite(); break;
				case 'fig': echo netblog_setting_fig(); break;
				case 'adv': echo netblog_setting_adv(); break;
				default: echo netblog_settings_general();
			}			
			?>
			<div class="netblog-clear"></div>						
		</div>
	</form>
	</div>
	<?php
	
	echo '</div>';
}

function netblog_settings_mkmenuclass( $button )
{
	if( isset($_GET['sub']) && $_GET['sub'] == $button )
		return 'lnk-active';
	else return 'lnk';
}

function netblog_settings_general()
{
	ob_start();
		
	$roles = array( 	'activate_plugins'=> __('Administrator','netblog'), 
						'delete_pages'=> __('Editor','netblog'), 
						'publish_posts'=> __('Author','netblog'), 
						'edit_posts'=> __('Contributor','netblog'), 
						'read'=> __('Subscriber','netblog')
	);
	$mel_tpl = array( 	'new'=>__('Just Added','netblog'), 
						'popular'=>__('Most Popular','netblog'), 
						'offline'=>__('Offline','netblog'), 
						'trash'=>__('Trashed','netblog') 
	);
	$saveOffset = array( 0=>__('Immediate','netblog'), 
						5=> vsprintf(_n("%d second", "%d seconds", 5, 'netblog'), 5), 
						10=>vsprintf(_n("%d second", "%d seconds", 10, 'netblog'), 10), 
						20=> vsprintf(_n("%d second", "%d seconds", 20, 'netblog'), 20), 
						45=> vsprintf(_n("%d second", "%d seconds", 45, 'netblog'), 45),
						60=> vsprintf(_n("%d second", "%d seconds", 60, 'netblog'), 60),
						120=> vsprintf(_n("%d min", "%d mins", 120, 'netblog'), 120),
						240=> vsprintf(_n("%d min", "%d mins", 240, 'netblog'), 240)
	);
	
	if( isset($_GET['rmtpl']) ) {
		netblog_mel_tpl_rm($_GET['rmtpl']);
		unset($_GET['rmtpl']);
	}

	$mel_tpls_user = netblog_mel_tpls();
	?>
	

	<label class="col1">MEL - <?php _e('Manage Extern Links','netblog'); ?></label>
	<div class="col2"><input type="checkbox" name="netblog_mel" value="true" id="mel-enable" 
				<?php checked( get_option('netblog_mel') == 'true', true ) ?> onclick="revealPara('mel-para',this)" /> 
			<label for="mel-enable" style="font-weight:normal"><?php _e('Enabled','netblog'); ?></label></div>	

	<div id="mel-para" style="display:<?php echo get_option('netblog_mel') == 'true' ? 'block' : 'none' ?>">		
	 	<div class="indent">
			<div class="col1"><?php _e('Startup Template','netblog'); ?></div></div>
		<div class="col2"><select name="netblog_mel_start_tpl"><optgroup label="Built-in Templates"><?php 
					$tpl = get_option('netblog_mel_start_tpl');
					foreach( $mel_tpl as $k=>$nm )
						echo '<option value="'.$k.'" '.selected( $k == $tpl, true, false).'>'.$nm.'</option>';
					?></optgroup>
				<optgroup label="Custom Templates"></optgroup></select></div>
			
	 	<div class="indent">
			<div class="col1"><?php _e('Custom Search Templates','netblog'); ?></div></div>
		<div class="col2">
			<input type="checkbox" name="netblog_mel_tpl" value="true" id="mel-tpl-enable" 
				<?php checked( get_option('netblog_mel_tpl') == 'true', true ) ?> onclick="revealPara('mel-para-custom-tpl',this)"/> 
				<label for="mel-tpl-enable" style="font-weight:normal"><?php _e('Enabled','netblog'); ?></label><br />
			<div id="mel-para-custom-tpl" style="display:<?php echo get_option('netblog_mel_tpl') == 'true' ? 'block' : 'none' ?>">
				<input type="text" name="mel-tpl-name" value="" size="15" onfocus="help('hmel-tpl-name',this)" 
						onblur="help('',null)" onkeydown="str2alphanumNW(this);input_strip(this,35)" title="<?php _e('Screen name','netblog'); ?>" />: 
					<input type="text" name="mel-tpl-val" value="" style="width:70%" onfocus="help('hmel-tpl-query',this)" onblur="help('',null)"
						 title="<?php printf( __('Your custom search query, e.g. %s','netblog'), 'wordpress tpl:new sort:id-desc,title limit:50 flag:offline' ); ?> " />
					<input type="submit" name="mel-add-tpl" value="<?php _e('Add Template','netblog'); ?>" />
				<div class="helpbox" id="hmel-tpl-name" style="display:none; position: relative"><div class="pad"><b><?php _e('Screen name','netblog'); ?></b><br />
					<?php printf(__('Maximum characters: %d','netblog'), 35 ); ?> | 
					<?php _e('alpha-numeric only','netblog'); ?> | 
					<?php _e('no whitespace','netblog'); ?>
					</div></div>
				<div class="helpbox" id="hmel-tpl-query" style="display:none; position: relative"><div class="pad"><b><?php _e('Search query','netblog'); ?></b><br />
					<p>
					<u><?php _e('Syntax','netblog'); ?></u><br />	
					[name]<br />				
					sort:[id,title,uri,refs,flag]<br />
					limit:[integer]<br />
					flag:[online,offline,trash]<br />
					tpl:[new,popular,offline,trash,valid custom template name]
					</p>
					<p>
					<u><?php _e('Example','netblog'); ?></u><br />
					wordpress sort:title,uri limit:20 flag:online<br />
					netblog tpl:popular
					</p>				
					</div></div>
				<div style="padding-top: 5px; padding-bottom:15px;"><?php
					foreach( $mel_tpls_user as $nm=>$val )
						echo '<a href="'.netblog_mkurl('rmtpl='.$nm).'" class="del"></a><div class="col1">'.$nm.'</div><div class="col2-sl">'.$val.'</div>';
				?></div>				
			</div>
		</div>
			
	 	<div class="indent">
			<div class="col1"><?php _e('Read/Access Privilege','netblog'); ?></div></div>
		<div class="col2"><select name="netblog_mel_read"><?php 
				$r = get_option('netblog_mel_read');
				foreach( $roles as $role=>$nm )
					echo '<option value="'.$role.'" '.selected( $role == $r, true, false).'>'.$nm.'</option>';
					
			?></select></div>	
			
	 	<div class="indent">
			<div class="col1"><?php _e('Edit Privilege','netblog'); ?></div></div>
		<div class="col2"><select name="netblog_mel_edit"><?php 
				$r = get_option('netblog_mel_edit');
				foreach( $roles as $role=>$nm )
					echo '<option value="'.$role.'" '.selected( $role == $r, true, false).'>'.$nm.'</option>';
					
			?></select></div>		
			
		<div class="indent">
			<div class="col1"><?php _e('Auto-save after modification','netblog'); ?></div></div>
		<div class="col2"><select name="netblog_mel_save"><?php 
				$r = get_option('netblog_mel_save');
				foreach( $saveOffset as $time=>$nm )
					echo '<option value="'.$time.'" '.selected( $time == $r, true, false).'>'.$nm.'</option>';
					
			?></select></div>	
	</div>
	
	<div class="lb"></div>		
	<label class="col1"><?php _e('Blogsearch','netblog'); ?></label>
	<div class="col2"><select name="blogsearch-preset"><option value=""><?php _e('Predefined Provider','netblog'); ?></option>
			<option value="google"><?php _e('Google Blogsearch','netblog'); ?></option></select>
			<input type="submit" name="blogsearch-tpl" value="<?php _e('Apply','netblog'); ?>" /></div>	
	 	<div class="indent">
			<div class="col1"><?php _e('Provider Name','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_provider_name" size="40" value="<?php echo get_option('netblog_blogsearch_provider_name'); ?>" />
		</div>	
	 	<div class="indent">
			<div class="col1"><?php _e('Provider URL','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_provider_uri" size="40" value="<?php echo get_option('netblog_blogsearch_provider_uri'); ?>" />			
		</div>	
	 	<div class="indent">
			<div class="col1"><?php _e('URL','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_uri" value="<?php echo get_option('netblog_blogsearch_uri'); ?>" style="width:100%" onfocus="help('hblog-uri',this)" onblur="help('',null)" />
			<div class="helpbox" id="hblog-uri" style="display:none; position: relative">
				<div class="pad"><b><?php _e('Blogsearch URL','netblog'); ?></b> 
					<small><i><?php _e('must return a valid XML Feed','netblog'); ?></i></small><br />
				<div class="netblog-indent-hang-long"><?php printf(__('%s := will be replaced either with Global Max Results or with a lower number
					so that the total number of links displayed will not exceed the maximum
					number defined by the user in the widget section.','netblog'),'??count??') ?></div>
				<div class="netblog-indent-hang-long"><?php printf(__('%s := will be replaced with the query.','netblog'),'??query??'); ?></div> 				
				</div></div>
		</div>
	 	<div class="indent">
			<div class="col1"><?php _e('Global Max Results','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_max" size="3" value="<?php echo get_option('netblog_blogsearch_max'); ?>" />
		</div>
	
	<div class="lb"></div>	
	<label class="col1"><?php _e('Websearch','netblog'); ?></label>
	<div class="col2">
		<select name="websearch-preset">
			<option value=""><?php _e('Predefined Provider','netblog'); ?></option>
			<option value="yahoo"><?php _e('Yahoo Websearch API','netblog'); ?></option></select>
		<input type="submit" name="blogsearch-tpl" value="<?php _e('Apply','netblog'); ?>" /></div>	
	 	<div class="indent">
			<div class="col1"><?php _e('Provider Name','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_provider_name" size="40" value="<?php echo get_option('netblog_websearch_provider_name'); ?>" />
		</div>	
	 	<div class="indent">
			<div class="col1"><?php _e('Provider URL','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_provider_uri" size="40" value="<?php echo get_option('netblog_websearch_provider_uri'); ?>" />
		</div>	
	 	<div class="indent">
			<div class="col1"><?php _e('URL','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_uri" value="<?php echo get_option('netblog_websearch_uri'); ?>" style="width:100%" onfocus="help('hbweb-uri',this)" onblur="help('',null)" />
			<div class="helpbox" id="hbweb-uri" style="display:none; position: relative">
				<div class="pad"><b><?php _e('Websearch URL','netblog'); ?></b> 
					<small><i><?php _e('must return a valid XML Feed','netblog'); ?></i></small><br />
				<div class="netblog-indent-hang-long"><?php printf(__('%s := will be replaced either with Global Max Results or with a lower number
					so that the total number of links displayed will not exceed the maximum
					number defined by the user in the widget section.','netblog'),'??count??') ?></div>
				<div class="netblog-indent-hang-long"><?php printf(__('%s := will be replaced with the query.','netblog'),'??query??'); ?></div>
				</div></div>
		</div>
	 	<div class="indent">
			<div class="col1"><?php _e('Global Max Results','netblog'); ?></div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_max" size="3" value="<?php echo get_option('netblog_websearch_max'); ?>" />
		</div>	
	
	<div class="lb"></div>	
	<label class="col1"><?php _e('Export & Import','netblog'); ?></label>
	<div class="col2">
		<p style="text-decoration:underline"><?php _e('Important: In version 1.5, links will be imported as external resources only.','netblog'); ?></p>
		<input type="submit" name="footprt_rebuild" value="<?php _e('Rebuild EED (Embedded Export Data)','netblog'); ?>" /> 
			<small><?php _e('<b>Note</b>: Only necessary just before update. They can NOT be seen by public website requests!','netblog'); ?></small><br /><br />
		<input type="submit" name="footprt_import" value="<?php _e('Import from EED','netblog'); ?>" /> 
			<small><?php _e('<b>Caution</b>: any existing attached links will be removed before importing links from EED!','netblog'); ?></small><br /><br />
		<input type="submit" name="footprt_rm-export-data" value="<?php _e('Remove EED','netblog'); ?>" /> 
			<small><?php _e('<b>Note</b>: after export, all current internal and external links will be lost; choose to save just a bit space.','netblog'); ?></small><br /><br />
		<input type="checkbox" name="netblog-export-build" value="save_post" id="netblog-export-build-checkbox" <?php checked( get_option('netblog-export-build') == 'save_post', true) ?> /> 
			<label for="netblog-export-build-checkbox" style="font-weight:normal"><?php _e('Automatically rebuild EED while saving a post/page','netblog'); ?></label>
		</div>
	
	<!-- 
	<div class="lb"></div>	
	<label class="col1"><?php _e('Footprints','netblog'); ?></label>
	<div class="col2">
		<input type="checkbox" name="netblog-footprints" value="save_post" id="netblog-footprints-checkbox" <?php checked( get_option('netblog-footprints') != 'false', true) ?> /> 
			<label for="netblog-footprints-checkbox" style="font-weight:normal"><?php _e('Activate Footprints','netblog'); ?></label><br />
			<small><?php _e('Note: This is still a Beta feature. If you deactivate Footprints, internal links will not be exported.', 'netblog') ?> <a href="netblog.benjaminsommer.com/footprints"><?php _e('Learn more about Footprints.', 'netblog') ?></a></small> 
		</div>
	-->
				
	<script type="text/javascript">
	<!--
	/* PRINT HELP BOX */

	var optHelp = document.getElementById('nb-help-enabled');

	var lastHelpBox = null;
	
	function help( helpid, sourceObj )
	{
	if( !optHelp.checked ) return;
	
	if( lastHelpBox != null && lastHelpBox.id != helpid )
		hidePlus( lastHelpBox.id, 0, 200, true, true );
		
	var box = document.getElementById(helpid);
	if( box == null )
		return;
	
	showPlus( box.id, 400, 200, true, true );
	lastHelpBox = box;

	}	
		
	function revealPara( targetid, inObj )
	{
		var target = document.getElementById(targetid);
		if( target == null ) return;
		
		if( inObj.checked )
			showPlus(targetid,0,250,true,false);
		else hidePlus(targetid,0,250,true,false); 
	}	

	-->
	</script>		
					
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}

function netblog_setting_note()
{
	ob_start();
		
	$formats = array( 'decimal'=>1, 
					  'lower-alpha' => 'a', 'lower-greek'=>'a', 'lower-roman'=>1,
					  'upper-alpha'=> 'A', 'upper-roman' =>1 );
	
	foreach( $formats as $k=>$v ) {
		$t = array();
		$i = 1;
		$t[0] = nbcpt::increment($i,$k,0);
		$t[1] = nbcpt::increment($i++,$k);
		$t[2] = nbcpt::increment($i++,$k);
		$t[3] = nbcpt::increment($i++,$k);
		$formats[$k] = implode(', ',$t) . ', ...';
	}
	
	?>
	<label class="col1"><?php _e('Location','netblog'); ?></label>
		<div class="col2"><select name="netblog_note_location">
			<option value="bottom"><?php _e('Bottom of page','netblog'); ?></option>
			<option value="inline"><?php _e('Inline','netblog'); ?></option></select></div>
	<label class="col1"><?php _e('Format','netblog'); ?></label>
		<div class="col2">&nbsp;</div>
	 	<div class="indent">
			<div class="col1"><?php _e('Number format','netblog'); ?></div></div>
		<div class="col2">
			<select name="netblog_note_format">
				<?php
				$f = get_option('netblog_note_format');
				
				foreach( $formats as $k=>$v )
					echo '<option value="'.$k.'" '.selected( $k==$f, true, false).'>'.$v.'</option>';
				?>
			</select></div>
		
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}



function netblog_setting_cite()
{
	ob_start();
	
	$styledft = get_option('netblog_cite_style');
	$styledftOverride = get_option('netblog_cite_style_override');
	
	$cstyles = nbcstyle::getStyles();
	$cstylesPrint = $cstyles;
	if( $cstylesPrint == '' ) $cstylesPrint = __('none','netblog');
	
	// MK SELECT FILTER TYPE
	$selectFilterType = '';
	$t = nbcstyle::getDftTypes();
	foreach($t as $k=>$v)		
		$selectFilterType .= "<option value=\"$k\">$v</option>";
		

	// MK SELECT CUSTOM STYLE
	$optioncStyle = '';
	$t = strlen($cstyles) > 0 ? explode(', ',$cstyles) : array();
	foreach( $t as $v )
		if( strlen($v) > 0 )
		$optioncStyle .= "<option value=\"$v\" ".selected( $v == $styledft, true, false ).">$v</option>";

	
	// MK SELECT DEFAULT STYLES
	$optionDftStyle = '';
	$t = nbcstyle::getDftStyles();
	foreach( $t as $v )
		$optionDftStyle .= "<option value=\"$v\" ".selected( $v == $styledft, true, false ).">$v</option>";
		
	?>
	<label class="col1"><?php _e('Tag Name','netblog'); ?></label>
	<div class="col2"><?php echo constant('NETBLOG_CITE_TAG'); ?></div>

	<label class="col1"><?php _e('Default Style','netblog'); ?></label>
	<div class="col2">
		<select name="netblog_cite_style">
			<optgroup label="<?php _e('Built-in Styles','netblog'); ?>"><?php echo $optionDftStyle ?></optgroup>
			<optgroup label="<?php _e('Custom Styles','netblog'); ?>"><?php echo $optioncStyle ?></optgroup></select>
		<a href="netblog.benjaminsommer.com/citation.html">Learn More</a>
		</div>			
	<div class="indent">
		<div class="col1"><label for="nb-cite-style-override" style="font-weight:normal"><?php _e('Force all posts to use this style','netblog'); ?></label></div></div>
	<div class="col2">
		<input type="checkbox" name="netblog_cite_style_override" value="true" id="nb-cite-style-override" <?php echo checked($styledftOverride=='true') ?> />
	</div>
		
	<label class="col1"><?php _e('Custom Styles','netblog'); ?></label>
	<div class="col2"><?php echo $cstylesPrint; ?></div>
	
	<div class="indent">
		<div class="col1"><?php _e('Add Filter','netblog'); ?></div>		
	</div>
	<div class="col2">
		<select onchange="nb_copyval2val(this,'custom_style')"><option value=""><?php _e('Style Name','netblog'); ?></option><?php echo $optioncStyle ?></select>
		<select onchange="nb_copyval2val(this,'custom_filtertype')"><option value=""><?php _e('Filter Type','netblog'); ?></option><?php echo $selectFilterType ?></select><br />
		<input type="text" size="10" name="custom_style" id="custom_style"  onkeyup="str2alphanum(this);netblog_count_chars(this,'cfilter-style-chars')" onfocus="helpbox('helpbox',this);netblog_count_chars(this,'cfilter-style-chars');" onblur="helpbox('helpbox',null)"
			 />-<input type="text" size="15" name="custom_filtertype" id="custom_filtertype" onkeyup="str2alphanum(this);netblog_count_chars(this,'cfilter-type-chars')" onfocus="helpbox('helpbox2',this);netblog_count_chars(this,'cfilter-type-chars');" onblur="helpbox('helpbox2',null)"
			 />-<input type="text" style="width:60%" name="custom_filter" id="custom_filter" onkeyup="netblog_cite_preview(this.value)" onfocus="helpbox('helpbox3',this)" onblur="helpbox('helpbox3',null)" />
		<input type="submit" value="<?php _e('Apply','netblog'); ?>" name="addfilter" />
		<div class="helpbox" id="helpbox" style="display:none; position: relative"></div>
		<div class="helpbox" id="helpbox2" style="display:none; position: relative"></div>
		<div class="helpbox" id="helpbox3" style="display:none; position: relative"></div>
		</div>
		
			
	<?php
	
	// LOAD CUSTOM FILTER
	$list = array();
	$cfilter = nbcstyle::getFilterRaw(true);
	foreach( $cfilter as $nm=>$val) {
		$style = nbcstyle::extractStyle($nm);
		$type = nbcstyle::extractType($nm);
		$list[$style][] = array('type'=>$type,'filter'=>$val);	
	}
	
	foreach($list as $style=>$filters ) {
		echo '
			<div class="indent">
				<div class="col1">'.$style.'</div>		
			</div>
			<div class="col2">';
		foreach( $filters as $row ) {
			extract($row);
			$filter = stripslashes($filter);
			echo "<a href=\"".netblog_mkurl('rmfilter='.$style.'-'.$type)."\" class=\"del\"></a><div class=\"col1\"> $type</div><div class=\"col2-sl\">$filter</div>";
		}
		echo '</div>';
	}

	// MK JS HEL - VALID ATTS
	$atts = nbcstyle::getDftAtts();
	$attsPtr = ''; 
	foreach( $atts as $att=>$dft ) {
		if( substr($att,0,strlen('print')) == 'print' ) continue;
		if( $dft != '' ) $dft = " [$dft]";
		$attsPtr .= '<div class="col"><a onclick="style_cfilter_append(\\\''.$att.' \\\')" style="cursor:pointer;color:#333">'.$att.'</a>'.$dft.'</div>';
	}
	
	?>
	<script type="text/javascript">
	<!--
	var protectedStyles = '<?php echo implode(', ', nbcstyle::getDftStyles() ); ?>';
	var validAtts = '';
	var maxChars = 20;
	var minChars = 3;
	
	var optHelp = document.getElementById('nb-help-enabled');
	var oCFilter = document.getElementById('custom_filter');
	
	/* APPLY SELECT VALUE TO HTML-ID-VALUE */
	function nb_copyval2val( objold, idnew )
	{
		document.getElementById(idnew).value = objold.value;
	} 
	
	/* PRINT HELP BOX */
	function helpbox( id, refObj )
	{
		if( !optHelp.checked ) return;
		var box = document.getElementById(id);
		if( refObj == null || typeof(refObj) == 'undefined' ) {
			//hide( box.id, 200, 200);
			hidePlus( box.id, 200, 500, true, true);
			return;
		}
			
		var refid = refObj.id;		
		var help = '';
		
		if( refid == 'custom_style' ) {			
			help += '<b><?php printf(__('Allowed characters','netblog'),''); ?></b>: a-z, A-Z, 0-9<br />';
			help += '<?php printf(__('Max characters: %s of %s','netblog'),'<span id="cfilter-style-chars">0</span>',''); ?> ' + maxChars + '<br />';
			help += '<?php printf(__('Protected Names: %s','netblog'),''); ?> ' + protectedStyles + '<br />';
		} else if( refid == 'custom_filtertype' ) {
			help += '<b><?php printf(__('Allowed characters','netblog'),''); ?></b>: a-z, A-Z, 0-9<br />';
			help += '<?php printf(__('Max characters: %s of %s','netblog'),'<span id="cfilter-type-chars">0</span>',''); ?> ' + maxChars + '<br />';
			help += '<?php _e('Use of an existing filter type for your custom style will overwrite the filter.','netblog'); ?>';
		} else if( refid == 'custom_filter' ) {
			help += '<b><?php _e('Preview','netblog'); ?></b>: <div id="nbcite-preview" style="display:inline"><?php _e('no preview available','netblog'); ?></div><br /><br />';
			help += '<div class="title"><?php _e('Valid Keywords','netblog'); ?></div><?php echo $attsPtr ?>';
		}
		
		if( help != '' ) {
			box.innerHTML = '<div class="pad"><div class="title"><?php _e('Help Tool','netblog'); ?></div>' + help + '<div class="netblog-clear"></div></div>';
			//show( box.id, 0, 200);			
			showPlus( box.id, 200, 200, true, true);
		} 
	}
	
	function style_cfilter_append( word )
	{
		if( oCFilter!=null ) {
			oCFilter.value = oCFilter.value + word;
			netblog_cite_preview(oCFilter.value);
			oCFilter.focus();
		}
	}
	
	
	function netblog_cite_preview( filter )
	{	
		jQuery(document).ready(function($) {
			var data = {
				action: 'cite_filter_preview',
				filter: filter
			};
			jQuery.post(ajaxurl, data, function(response) {
				if( response == '' || response == 'false' )
					response = 'No Preview';
					
				var prev = document.getElementById('nbcite-preview');
				if( prev != null ) {
					prev.innerHTML = response;
				};				
			});
		});	
	}
	
	//-->
	</script> 
	
	<?php
	
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}


function netblog_setting_fig()
{
	ob_start();
	
	$roles = array( 	'activate_plugins'=>__('Administrator','netblog'), 
						'delete_pages'=>__('Editor','netblog'), 
						'publish_posts'=>__('Author','netblog'), 
						'edit_posts'=>__('Contributor','netblog')
	);
	
	$gadd = get_option('netblog_caption_gadd');
	
	$formats = array( 'decimal'=>1, 
					  'lower-alpha' => 'a', 'lower-greek'=>'a', 'lower-roman'=>1,
					  'upper-alpha'=> 'A', 'upper-roman' =>1 );
	
	$display = array( 	'inline'=>__('Inline','netblog'), 
						'left'=>__('Left','netblog'),
						'right'=>__('Right','netblog')
	);
	
	foreach( $formats as $k=>$v ) {
		$t = array();
		$i = 1;
		$t[0] = nbcpt::increment($i,$k,0);
		$t[1] = nbcpt::increment($i++,$k);
		$t[2] = nbcpt::increment($i++,$k);
		$t[3] = nbcpt::increment($i++,$k);
		$formats[$k] = implode(', ',$t) . ', ...';
	}	
	
	?>
	<label class="col1" title="<?php _e('Captions are automatically added when first declared in a post/page and if this privilege is met.','netblog'); ?>">
		<?php _e('Who may add global types?','netblog'); ?></label>
	<div class="col2"><select name="netblog_caption_gadd">
		<?php
		foreach( $roles as $k=>$v )
			echo '<option value="'.$k.'" '.selected($k==$gadd,true,false).'>'.$v.'</option>';
		?>
	</select></div>

		
	<?php
	
	
	$types = nbdb::cptg_getTypes(true);
	foreach( $types as $type=>$para ) {
		?>
		<div style="float:left;display:block;width:400px; padding-right: 50px">
		<div class="col1"><input type="checkbox" name="nb-caption-<?php echo $type ?>-active" id="nb-caption-<?php echo $type ?>" value="true" <?php checked($para['active']) ?>
					onclick="revealPara('nb-caption-typepara-<?php echo $type ?>',this)"	/>
				<label for="nb-caption-<?php echo $type ?>" 
					title="<?php _e('When active, these settings will override all captions in any post and in any page.','netblog'); ?>">
					<?php echo ucfirst($type); ?></label>
				<input type="hidden" name="nb-caption-types[]" value="<?php echo $type ?>" /></div>
			<div class="col2"><select name="nb-caption-<?php echo $type ?>-display">
				<?php
					foreach( $display as $k=>$v )
						echo '<option value="'.$k.'" '.selected( $k==$para['display'],true,false ).' >'.$v.'</option>';
				 ?>
				</select></div>	
			<div id="nb-caption-typepara-<?php echo $type ?>" style="display:<?php echo $para['active'] ? 'block' : 'none'; ?>">
			 	<div class="indent">
					<div class="col1"><?php _e('Number format','netblog'); ?></div>	
				</div>
				<div class="col2"><select name="nb-caption-<?php echo $type ?>-numformat">
					<?php 
						foreach( $formats as $k=>$v) 
							echo '<option value="'.$k.'" '.selected( $k==$para['number_format'] ).'>'.$v.'</option>';
					 ?></select></div>
			 	<div class="indent">
					<div class="col1"><?php _e('Print format','netblog'); ?></div>	
				</div>
				<div class="col2"><input type="text" name="nb-caption-<?php echo $type ?>-format" value="<?php echo $para['print_format'] ?>" /></div>
			 	<div class="indent">
					<label class="col1" for="nb-caption-<?php echo $type ?>-remove" style="font-weight:normal;font-style:italic"><?php _e('Remove permanently','netblog'); ?></label>	
				</div>
				<div class="col2"><input type="checkbox" name="nb-caption-<?php echo $type ?>-remove" id="nb-caption-<?php echo $type ?>-remove" value="true" /></div>
			<hr style="border: 1px solid #EEE" />
			</div>			
		</div>			
		<?php		
	}
	
	?>
	<div class="netblog-clear" style="height:30px"></div>
	
	<div class="col1"><label ><?php _e('Create a new type','netblog'); ?></label></div>
	<div class="col2"><input type="text" name="nb-caption-type-new" id="nb-caption-type-new" value="" onkeydown=";str2alphanum(this);input_strip(this,32);revealOnInput(this,'nb-caption-new')" /></div>	
	<div id="nb-caption-new" style="display:none">
	 	<div class="indent">
			<div class="col1"><?php _e('Number format','netblog'); ?></div>	
		</div>
		<div class="col2"><select name="nb-caption-new-numformat">
			<?php 
				foreach( $formats as $k=>$v) 
					echo '<option value="'.$k.'">'.$v.'</option>';
			 ?></select></div>
	 	<div class="indent">
			<div class="col1"><?php _e('Display','netblog'); ?></div>	
		</div>
		<div class="col2"><select name="nb-caption-new-display">
			<?php 
				foreach( $display as $k=>$v) 
					echo '<option value="'.$k.'">'.$v.'</option>';
			 ?></select></div>		 
	 	<div class="indent">
			<div class="col1"><?php _e('Print format','netblog'); ?></div>	
		</div>
		<div class="col2"><input type="text" name="nb-caption-new-format" value="($number)" /></div>
	</div>
	
	
	<label class="col1" title=""><?php _e('Advanced','netblog'); ?></label>
	<div class="col2">
		<input type="submit" name="nb-caption-rebuild" value="<?php _e('Rebuild Caption Numbers','netblog'); ?>" /></div>
		
		
	<script type="text/javascript">
	<!--
	var minCharType = 3;
	function revealOnInput( inObj, targetid )
	{
		var target = document.getElementById(targetid);
		if( target == null ) return;
	
		if( target.style.display == '' ) 
			target.style.display = 'none';
		
		if( inObj.value.length == minCharType-1 && target.style.display != 'none' )
			hidePlus(targetid,0,250,true,false);
		else if( inObj.value.length == minCharType && target.style.display == 'none' )
			showPlus(targetid,0,250,true,false);
	}
	
	function revealPara( targetid, inObj )
	{
		var target = document.getElementById(targetid);
		if( target == null ) return;
		
		if( inObj.checked )
			showPlus(targetid,0,250,true,false);
		else hidePlus(targetid,0,250,true,false); 
	}	
	//-->
	</script>
				
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;	
	
}

function netblog_setting_adv()
{
	
	ob_start();
	
	?>
	 
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}


function netblog_settings_update( $sub )
{			
	// PAGE-SPECIFIC
	switch($sub) {
		//case 'note': echo netblog_setting_note(); break;
		case 'cite': echo netblog_settings_upd_cite(); break;
		case 'fig': echo netblog_settings_upd_fig(); break;
		//case 'adv': echo netblog_setting_adv(); break;
		default: echo netblog_settings_upd_general();
	}
	
	// UPDATE OPTION - GENERIC
	foreach( $_POST as $nm=>$val )
	if( is_string($val) && strlen($val) > 0 && get_option($nm) !== false )
		update_option($nm,$val);
	
	if( isset($_POST) && sizeof($_POST) > 0 )
		echo __('Settings updated.','netblog');
}
function netblog_settings_upd_cite(){
	if( !isset($_POST['netblog_cite_style_override']) )
	update_option('netblog_cite_style_override','false');
	
	if( isset($_POST['custom_style']) && isset($_POST['custom_filtertype']) && isset($_POST['custom_filter']) 
		&& strlen($_POST['custom_style']) > 2 && strlen($_POST['custom_filtertype']) > 2 && strlen($_POST['custom_filter']) > 2 ) {
		extract($_POST);
		if( ctype_alnum($custom_style) && ctype_alnum($custom_filtertype) && strlen($custom_filter) > 0 ) {
			nbcstyle::addFilter($custom_style, $custom_filtertype, $custom_filter);
			echo '<strong>'.__('Added custom filter','netblog').'</strong> | ';
		} else echo '<strong>'.__('Invalid characters in your citation style','netblog').'</strong> | ';
	} else if( isset($_GET['rmfilter']) ) {
		$t = explode('-',$_GET['rmfilter']);
		nbcstyle::rmFilter( $t[0], $t[1] );
		echo '<strong>'.__('Filter removed','netblog').'</strong>';
	} else if( sizeof($_POST) > 0 ) {
		echo '<strong>'.__('Incomplete citation style','netblog').'</strong> | ';
	}
	
	if( isset($_GET['rmfilter']) ) {
		$t = explode('-',$_GET['rmfilter']);
		nbcstyle::rmFilter( $t[0], $t[1] );
	}
	unset($_GET['rmfilter']);
}

function netblog_settings_upd_general()
{
	// GET ONLY //
	
	// POST ONLY //
	if( sizeof($_POST) == 0 ) return;
	
	if( isset($_POST['blogsearch-preset']) && $_POST['blogsearch-preset'] == 'google' ) {
		$t = array('NETBLOG_BLOGSEARCH_URI','NETBLOG_BLOGSEARCH_MAX','NETBLOG_BLOGSEARCH_PROVIDER_NAME','NETBLOG_BLOGSEARCH_PROVIDER_URI');
		foreach( $t as $nm )
			if(isset($_POST[strtolower($nm)]) ) $_POST[strtolower($nm)] = constant($nm); 
	}
	if( isset($_POST['websearch-preset']) && $_POST['websearch-preset'] == 'yahoo' ) {
		$t = array('NETBLOG_WEBSEARCH_URI','NETBLOG_WEBSEARCH_MAX','NETBLOG_WEBSEARCH_PROVIDER_NAME','NETBLOG_WEBSEARCH_PROVIDER_URI');
		foreach( $t as $nm )
			if(isset($_POST[strtolower($nm)]) ) $_POST[strtolower($nm)] = constant($nm);
	}	
	
	if( !isset($_POST['netblog_mel_tpl']) )
		update_option('netblog_mel_tpl','false');
	if( !isset($_POST['netblog_mel']) )
		update_option('netblog_mel','false');		
			
	if( /*isset($_POST["mel-add-tpl"]) &&*/ strlen($_POST["mel-tpl-name"]) > 0 && strlen($_POST["mel-tpl-val"]) > 0 ) {
		//$_POST['mel-tpl-name'] = netblog_str2alnum($_POST['mel-tpl-name'], false);
		netblog_mel_tpl_add( $_POST["mel-tpl-name"], $_POST["mel-tpl-val"] );
	}
	
	// REBUILD EXPORT DATA
	if( isset($_POST['footprt_rebuild']) && strlen($_POST['footprt_rebuild']) > 0 )
		nbdb::rsc_exportRebuild(true);
		
	// RESTORE FROM EXPORT DATA
	if( isset($_POST['footprt_import']) && strlen($_POST['footprt_import']) > 0 )
		nbdb::rsc_importAll(true);
	
	// REMOVE EXPORT DATA
	if( isset($_POST['footprt_rm-export-data']) && strlen($_POST['footprt_rm-export-data']) > 0 )
		nbdb::rsc_rmExportData();
	
	// OPTION: REBUILD EXPORT DATA UPON SAVE
	if( !isset($_POST['netblog-export-build']) )
		update_option('netblog-export-build','manual');	

	// OPTIONA: FOOTPRINTS
	if( !isset($_POST['netblog-footprints']) )
		update_option('netblog-footprints','false');
}

function netblog_settings_upd_fig()
{
	$scope = 'nb-caption-';
	if( !isset($_POST[$scope.'types']) ) return;
	
	if( isset($_POST[$scope.'type-new']) && strlen($_POST[$scope.'type-new']) > 0
		 && !in_array(strtolower($_POST[$scope.'type-new']),$_POST[$scope.'types'])
		 && nbdb::cptg_get($_POST[$scope.'type-new']) == null ) {
		nbdb::cptg_set( $_POST[$scope.'type-new'], $_POST[$scope.'new-numformat'], $_POST[$scope.'new-format'], $_POST[$scope.'new-display'] );
		echo vsprintf(__('Added caption type %s.','netblog'),'<i>"'.$_POST[$scope.'type-new'].'"</i>');
	}

	foreach( $_POST[$scope.'types'] as $type ) {
		if( strlen($type) == 0 ) continue;
		
		// ALLOW WHITESPACES - POST CONVERTS WHITESPACE TO _		
		
		$t = $scope.str_replace(' ','_',$type).'-';
		
		$active = false;
		if( isset($_POST[$t.'active']) && $_POST[$t.'active'] == 'true' ) $active = true;
		
		if( isset($_POST[$t.'remove']) && $_POST[$t.'remove'] == 'true' ) {
			nbdb::cptg_rm($type);
			echo vsprintf(__('Removed caption type %s.','netblog'),'<i>"'.$type.'"</i>');
		} else		
			nbdb::cptg_set( $type, $_POST[$t.'numformat'], $_POST[$t.'format'], $_POST[$t.'display'],$active,true );
	}
		
	if( isset($_POST['nb-caption-rebuild']) && strlen($_POST['nb-caption-rebuild']) > 0 )
		if( nbdb::cptg_rebuild() )
			echo __('Rebuild caption numbers. ','netblog');
		else echo __('Failed to rebuild caption numbers. ','netblog');	
}


?>